; /fire /ele-earth draws 2 each
alias air {
  window -a %drw.win
  var %c = 0, %s = 2, %bgc = 1
  ; clearwin2 %bgc
  ; 2
  curve 460 140 35 25 %c %s 7 -34
  drawrect -f %drw.win %bgc 1 486 145 12 40
  curve 433 156 88 60  %c %s 2 100

  curve 475 240 50 40 %c %s 7
  drawrect -f %drw.win %bgc 1 422 215 40 40
  curve 450 225 17 30 %c %s 6 -45

  curve 544 240 20 20 %c %s 7
  curve 583 240 20 20 %c %s 7
  curve 622 240 20 20 %c %s 7
  drawrect -f %drw.win %bgc 1 631 218 40 40
  curve 639 205 32 20 %c %s 1 -18

  curve 535 220 90 40 %c %s 1 -10
  ; underline
  drawrect -f %drw.win %bgc 1 619 233 5 6

  ; top of loop
  curve 655 250 44 34  %c %s 3 72
  ; piece
  curve 664 212 5 5 %c %s 3 -25
  ; loop
  curve 430 370 130 100 %c %s 3
  curve 670 370 130 100 %c %s 4
  curve 550 370 10 20 %c %s 6

  drawtext -o  %drw.win %c Arial 12 550 415 AIR
  drawtext -o  %drw.win %c Arial 12 550 430 Rafael
  drawtext -o  %drw.win %c Arial 12 550 445 Sylph
}
alias ele-earth {
  window -a %drw.win
  var %c = 9, %s = 2, %bgc = 1
  clearwin2 %bgc
  curve 280 100 110 110 %c %s 2
  drawrect -f %drw.win %bgc 1 168 97 12 40
  curve 160 145 20 30 %c %s 7 20

  curve 332 504 300 160 %c %s 3 100
  drawrect -f %drw.win %bgc 1 160 310 40 230

  curve 171 298 20 20 %c %s 1 -40
  curve 171 298 20 20 %c %s 2 -40
  curve 171 298 20 20 %c %s 4 -40
  curve 171 298 20 20 %c %s 3 40

  curve 219 267 90 40 %c %s 1 -60

  curve 252 330 20 20 %c %s 1 40
  curve 252 330 20 20 %c %s 3 40

  curve 214 285 90 40 %c %s 2 40

  drawline %drw.win %c %s 256 239 280 239
  drawline %drw.win %c %s 238 256 280 256
  drawline %drw.win %c %s 225 273 280 273

  curve 272 177 9 9 %c %s 5
  drawline %drw.win %c %s  265 177 281 177

  curve 194 181 80 20 %c %s 7 45
  curve 281 125 37 28 %c %s 1 -73
  curve 253 133 10 3 %c %s 4 -70

  drawtext -o  %drw.win %c Arial 12 180 420 EARTH
  drawtext -o  %drw.win %c Arial 12 180 435 Uriel
  drawtext -o  %drw.win %c Arial 12 180 450 Gnome
  air
}
alias clearwin2 {
  drawrect -f %drw.win $1 1 0 0 %drw.w %drw.h
}
alias water {
  window -a %drw.win

  var %c = 11, %s = 2, %bgc = 1
  ; clearwin2 %bgc
  ; color size x y radius length
  wave %c %s 450 100 10 215
  wave %c %s 450 125 10 215

  curve 460 230 200 50 %c %s 1 55
  curve 655 230 200 50 %c %s 2 -55
  curve 558 83 25 25 %c %s 3 45

  curve 518 330 160 40 %c %s 1 100
  curve 596 330 160 40 %c %s 2 -100

  curve 503 344 14 14 %c %s 6 -5
  ; bottom half loop

  curve 540 350 100 25 %c %s 2 -100

  curve 528 374 50 30 %c %s 4 -40
  curve 565 328 50 30 %c %s 1 -40

  curve 580 374 38 25 %c %s 3 50
  curve 540 338 50 30 %c %s 2 40

  drawtext -o  %drw.win %c Arial 12 480 415 WATER
  drawtext -o  %drw.win %c Arial 12 480 430 Gabriel
  drawtext -o  %drw.win %c Arial 12 480 445 Undine
  drawtext -o  %drw.win %c Arial 12 480 460 (Chemical pronunciation Undeen)
}
alias wave {
  var %c = $1, %s = $2
  var %x = $3, %y, %r = 0.15, %div = 0.1
  var %radius = $5, %i = 0, %yp = $4, %previous
  while (%i < $6) {
    inc %i
    %y = $round($calc($sin(%r) * %radius + %yp),0)
    if (%previous) drawline %drw.win %c %s %previous %x %y
    %previous = %x %y
    inc %r %div
    inc %x
  }
}
alias fire {
  ; X + (Y*R/B) = R
  var %c = 7, %s = 2, %bgc = 1
  clearwin2 %bgc

  curve 180 100 30 20 %c %s 7 90
  curve 180 145 31 21 %c %s 7 90
  ;  curve 180 190 32 22 %c %s 7 90
  curve 180 250 50 50 %c %s 7 90

  ; reverse S
  curve 225 78 9 9 %c %s 3 0
  curve 225 90 16 5 %c %s 1 50

  curve 232 96 16 5 %c %s 4 50
  curve 229 108 9 9 %c %s 2 0
  ; 2
  curve 208 155 70 40 %c %s 7 -115
  drawrect -f %drw.win %bgc 1 177 215 20 10
  curve 180 190 32 22 %c %s 7 90
  drawline %drw.win %c %s 197 219 310 219
  drawline %drw.win %c %s 284 144 208 272 200 238 300 238

  drawtext -o  %drw.win %c Arial 12 180 350 FIRE
  drawtext -o  %drw.win %c Arial 12 180 365 Michael
  drawtext -o  %drw.win %c Arial 12 180 380 Salamander
  water
}
