
alias solid-pov-sph {
  ; (<x,y,z,size,P_Gold1-5,Finsh_MetalA)
  return sphere $chr(123) $&
    $+(<,$1,$chr(44), $2,$chr(44), $3,>,$chr(44)) $4 $&
    texture $chr(123) $&
    pigment $chr(123) $5 $chr(125) $&
    finish $chr(123) $6 $chr(125) $chr(125) $chr(125)
  ; texture { pigment { P_Gold1 } finish { F_MetalA } }
}
alias cglass-pov-sph {
  ; (<x,y,z,size,P,F)
  return sphere $chr(123) $&
    $+(<,$1,$chr(44), $2,$chr(44), $3,>,$chr(44)) $4 $&
    texture $chr(123) $&
    pigment $chr(123) $5 $chr(125) $&
    finish $chr(123) $6 $chr(125) $chr(125) $&
    interior $chr(123) Interior_Glass caustics 1 $chr(125) $chr(125)
  ; Example
  //e $glass-pov-obj(1,2,3,)
}
alias povcolorv {
  if (($1 isnum) && ((!$1) || ($1 > 130))) return 130
  var %f = $scriptdir $+ colors.inc
  var %w = $+(*,$1,*)
  if ($1 isnum) %w = $+(*,$pov-color($1),*)
  var %r = $read(%f,nw,%w)
  var %c = $gettok(%r,2,61)
  if ($gettok(%c,1,32) == color) %c = $remove(%c,color,red,green,blue,$chr(59))
  if ($gettok(%c,1,32) == white) {
    %c = $gettok(c,2,42)
    %c = $multv(1 1 1,%c)
  }
  if ($gettok(%c,1,32) == rgb) {
    %c = $remove(%c,rgb,<,>,$chr(44),$chr(59))
    if ($numtok(%c,32) == 1) %c = $multv(1 1 1,%c)
  }
  if ($gettok(%c,1,32) == rgbf) {
    %c = $remove(%c,rgb,<,>,$chr(44),$chr(59),f)
    if ($numtok(%c,32) == 1) %c = $multv(1 1 1,%c) 1
  }
  ; doublespace removal
  tokenize 32 %c
  %c = $1-
  if (%c) return %c
  return 0
  return $replace(%c,$chr(32),$chr(44))
  return $gettok($gettok(%r,1,61),2,32) = $replace(%c,$chr(32),$chr(44))
}
alias pov-pal {
  ; (0,1)
  %cmatrix = 1.0 0.0 0.0 0.0 0.939694113753738 0.342016041402412 0.0 -0.342016041402412 0.939694113753739 -1.0 0.0 0.0
  %wmatrix = 1.000000 0.000000 0.000000 0.000000 0.939694 -0.342016 0.000000 0.342016 0.939694 -1.0 0.0 0.0
  var %d1 = $1
  ; 15 x 11 
  var %d = C:\programing\povray3.6\bin\pvengine.exe
  if (!%framei) %framei = 0
  var %f1 = $+($scriptdir,palet,$pad(%framei,3,0),.pov)
  var %f = $+($scriptdir,pov-script.txt)
  var %str = Gold Chrome Silver Brass Copper
  .copy -o %f %f1
  var %i = 0, %p, %s = 0.44, %sz = $did(builder,10).text, %pig
  if ((%sz) && (%sz != %mol.scale)) {
    %sz = %mol.scale - %sz
    inc %sz %mol.scale
  }
  else %sz = %mol.scale
  var %sp = -63.0 -45.0 0.0, %v = 9.0 0.0 0.0, %col, %row, %v2 = 0.0 9.0 0.0
  while (%i < 165) {
    inc %i
    if (10) {
      %col = $int($calc((%i - 1) % 15))
      %row = $int($calc((%i - 1) / 15))
      %p = $addv($addv(%sp,$multv(%v,%col)),$multv(%v2,%row))
      %p = $popmatrix(%p)
      %p = $divv(%p,9)
    }
    else {
      %p = %mol. [ $+ [ %i ] ]
      %p = $popmatrix(%p)
      %p = $divv(%p,%sz)
    }
    tokenize 32 %p
    %pig = $pov-color($calc(%i + 0))
    if (%d1) write %f1 $solid-pov-sph($1, $calc($2 * -1), $3, %s,%pig,Finsh_MetalA)
    else write %f1 $solid-pov-obj($1, $calc($2 * -1), $3, %s, [ $rgb2gl($rgb($rndpal)) ] ,Finsh_MetalA)
  }
  write %f1 $chr(125)
  if (0) {
    write %f1  union $chr(123)
    write %f1  object $chr(123) Floor $chr(125)
    ; write %f1  object $chr(123) Floor1 $chr(125)
    write %f1  object $chr(123) Spheres $chr(125)
    write %f1 // rotate -y*35
  }
  ; write %f1  $chr(125)
  run %d /RENDER  %f1
}
alias povcolors {
  var %f = $+($scriptdir,colors2.txt)
  var %i = 0, %n = $lines(%f), %r
  while (%i < %n) {
    inc %i
    %r = $read(%f,n,%i)
    e $gettok(%r,1,61) $chr(36) $+ &
  }
  e %n
}
alias pov-color {
  if  ($1 > 155) return $gpov-color($calc($1 - 155))
  if (!$1) return $calc(36 + 44 + 50 + 25)
  if (($1 > -1) && ($1 < 37)) {
    return $gettok( $&
      Red $&
      Green $&
      Blue $&
      Yellow $&
      Cyan $&
      Magenta $&
      Clear $&
      White $&
      Black $&
      Gray05 $&
      Gray10 $&
      Gray15 $&
      Gray20 $&
      Gray25 $&
      Gray30 $&
      Gray35 $&
      Gray40 $&
      Gray45 $&
      Gray50 $&
      Gray55 $&
      Gray60 $&
      Gray65 $&
      Gray70 $&
      Gray75 $&
      Gray80 $&
      Gray85 $&
      Gray90 $&
      Gray95 $&
      DimGray $&
      DimGrey $&
      Gray $&
      Grey $&
      LightGray $&
      LightGrey $&
      VLightGray $&
      VLightGrey,$1,32)
  }
  if (($1 > -1) && ($1 < $calc(37 + 44))) {
    return $gettok( $&
      Aquamarine $&
      BlueViolet $&
      Brown $&
      CadetBlue $&
      Coral $&
      CornflowerBlue $&
      DarkGreen $&
      DarkOliveGreen $&
      DarkOrchid $&
      DarkSlateBlue $&
      DarkSlateGray $&
      DarkSlateGrey $&
      DarkTurquoise $&
      Firebrick $&
      ForestGreen $&
      Gold $&
      Goldenrod $&
      GreenYellow $&
      IndianRed $&
      Khaki $&
      LightBlue $&
      LightSteelBlue $&
      LimeGreen $&
      Maroon $&
      MediumAquamarine $&
      MediumBlue $&
      MediumForestGreen $&
      MediumGoldenrod $&
      MediumOrchid $&
      MediumSeaGreen $&
      MediumSlateBlue $&
      MediumSpringGreen $&
      MediumTurquoise $&
      MediumVioletRed $&
      MidnightBlue $&
      Navy $&
      NavyBlue $&
      Orange $&
      OrangeRed $&
      Orchid $&
      PaleGreen $&
      Pink $&
      Plum $&
      Salmon,$calc($1 - 36),32)
  }
  if (($1 > -1) && ($1 < $calc(37 + 44 + 50))) {
    return $gettok( $&
      SeaGreen $&
      Sienna $&
      SkyBlue $&
      SlateBlue $&
      SpringGreen $&
      SteelBlue $&
      Tan $&
      Thistle $&
      Turquoise $&
      Violet $&
      VioletRed $&
      Wheat $&
      YellowGreen $&
      SummerSky $&
      RichBlue $&
      Brass $&
      Copper $&
      Bronze $&
      Bronze2 $&
      Silver $&
      BrightGold $&
      OldGold $&
      Feldspar $&
      Quartz $&
      Mica $&
      NeonPink $&
      DarkPurple $&
      NeonBlue $&
      CoolCopper $&
      MandarinOrange $&
      LightWood $&
      MediumWood $&
      DarkWood $&
      SpicyPink $&
      SemiSweetChoc $&
      BakersChoc $&
      Flesh $&
      NewTan $&
      NewMidnightBlue $&
      VeryDarkBrown $&
      DarkBrown $&
      DarkTan $&
      GreenCopper $&
      DkGreenCopper $&
      DustyRose $&
      HuntersGreen $&
      Scarlet $&
      Med_Purple $&
      Light_Purple $&
      Very_Light_Purple,$calc($1 - (36 + 44)),32)
  }
  return $gettok( $&
    P_Gold1 $&
    P_Gold2 $&
    P_Gold3 $&
    P_Gold4 $&
    P_Gold5 $&
    P_Chrome1 $&
    P_Chrome2 $&
    P_Chrome3 $&
    P_Chrome4 $&
    P_Chrome5 $&
    P_Silver1 $&
    P_Silver2 $&
    P_Silver3 $&
    P_Silver4 $&
    P_Silver5 $&
    P_Brass1 $&
    P_Brass2 $&
    P_Brass3 $&
    P_Brass4 $&
    P_Brass5 $&
    P_Copper1 $&
    P_Copper2 $&
    P_Copper3 $&
    P_Copper4 $&
    P_Copper5,$calc($1 - (36 + 44 + 50)),32)
}
alias gpov-color {
  if  ($1 > 96) return $pov-color($calc($1 - 96))
  if (!$1) return $calc(45 + 51)
  if (($1 > -1) && ($1 < 46)) {
    return $gettok( $&
      Col_Winebottle $&
      Col_Beerbottle $&
      Col_Ruby $&
      Col_Green $&
      Col_Dark_Green $&
      Col_Yellow $&
      Col_Orange $&
      Col_Vicksbottle $&
      Col_Red_01 $&
      Col_Red_02 $&
      Col_Red_03 $&
      Col_Red_04 $&
      Col_Green_01 $&
      Col_Green_02 $&
      Col_Green_03 $&
      Col_Green_04 $&
      Col_Blue_01 $&
      Col_Blue_02 $&
      Col_Blue_03 $&
      Col_Blue_04 $&
      Col_Yellow_01 $&
      Col_Yellow_02 $&
      Col_Yellow_03 $&
      Col_Yellow_04 $&
      Col_Amethyst_01 $&
      Col_Amethyst_02 $&
      Col_Amethyst_03 $&
      Col_Amethyst_04 $&
      Col_Amethyst_05 $&
      Col_Amethyst_06 $&
      Col_Apatite_01 $&
      Col_Apatite_02 $&
      Col_Apatite_03 $&
      Col_Apatite_04 $&
      Col_Apatite_05 $&
      Col_Aquamarine_01 $&
      Col_Aquamarine_02 $&
      Col_Aquamarine_03 $&
      Col_Aquamarine_04 $&
      Col_Aquamarine_05 $&
      Col_Aquamarine_06 $&
      Col_Azurite_01 $&
      Col_Azurite_02 $&
      Col_Azurite_03 $&
      Col_Azurite_04,$1,32)
  }
  return $gettok( $&
    Col_Citrine_01 $&
    Col_Citrine_02 $&
    Col_Citrine_03 $&
    Col_Emerald_01 $&
    Col_Emerald_02 $&
    Col_Emerald_03 $&
    Col_Emerald_04 $&
    Col_Emerald_05 $&
    Col_Emerald_06 $&
    Col_Emerald_07 $&
    Col_Fluorite_01 $&
    Col_Fluorite_02 $&
    Col_Fluorite_03 $&
    Col_Fluorite_04 $&
    Col_Fluorite_05 $&
    Col_Fluorite_06 $&
    Col_Fluorite_07 $&
    Col_Fluorite_08 $&
    Col_Fluorite_09 $&
    Col_Gypsum_01 $&
    Col_Gypsum_02 $&
    Col_Gypsum_03 $&
    Col_Gypsum_04 $&
    Col_Gypsum_05 $&
    Col_Gypsum_06 $&
    Col_Ruby_01 $&
    Col_Ruby_02 $&
    Col_Ruby_03 $&
    Col_Ruby_04 $&
    Col_Ruby_05 $&
    Col_Sapphire_01 $&
    Col_Sapphire_02 $&
    Col_Sapphire_03 $&
    Col_Topaz_01 $&
    Col_Topaz_02 $&
    Col_Topaz_03 $&
    Col_Tourmaline_01 $&
    Col_Tourmaline_02 $&
    Col_Tourmaline_03 $&
    Col_Tourmaline_04 $&
    Col_Tourmaline_05 $&
    Col_Tourmaline_06 $&
    Col_Amber_01 $&
    Col_Amber_02 $&
    Col_Amber_03 $&
    Col_Amber_04 $&
    Col_Amber_05 $&
    Col_Amber_06,$calc($1 - 45),32)
  ; $&
    ;   Col_Amber_07 $&
    ; Col_Amber_08 $&
    ; Col_Amber_09
}
alias fpov-color {
  return $gettok( $&
    Col_Glass_Old $&
    Col_Glass_Winebottle $&
    Col_Glass_Beerbottle $&
    Col_Glass_Ruby $&
    Col_Glass_Green $&
    Col_Glass_Dark_Green $&
    Col_Glass_Yellow $&
    Col_Glass_Orange $&
    Col_Glass_Vicksbottle $&
    Col_Glass_Clear $&
    Col_Glass_General $&
    Col_Glass_Bluish,$1,32)
}
alias pov-pal2 {
  ; 15 x 11      and here     7 x 5
  var %d = C:\programing\povray3.6\bin\pvengine.exe
  if (!%framei) %framei = 0
  var %f1 = $+($scriptdir,palet,$pad(%framei,3,0),.pov)
  var %f = $+($scriptdir,pov-script.txt)
  var %str = Gold Chrome Silver Brass Copper
  .copy -o %f %f1
  var %i = 0, %p, %s = 0.26, %sz = $did(builder,10).text, %pig
  if ((%sz) && (%sz != %mol.scale)) {
    %sz = %mol.scale - %sz
    inc %sz %mol.scale
  }
  else %sz = %mol.scale
  var %sp = -15.0 -10.0 0.0, %v = 5.0 0.0 0.0, %col, %row, %v2 = 0.0 5.0 0.0
  while (%i < 35) {
    inc %i
    %col = $int($calc((%i - 1) % 7))
    %row = $int($calc((%i - 1) / 7))
    %p = $addv($addv(%sp,$multv(%v,%col)),$multv(%v2,%row))
    %p = $popmatrix(%p)
    %p = $divv(%p,4)
    tokenize 32 %p
    %s = 0.6
    %pig = $gpov-color($calc(%i + 0))
    write %f1 $solid-pov-sph($1, $calc($2 * -1), $3, %s,%pig,Finsh_MetalA)
    ;  write %f1 $cglass-pov-sph($1, $calc($2 * -1), $3, %s,%pig, Finsh_Glass)
  }
  write %f1 $chr(125)
  if (0) {
    write %f1  union $chr(123)
    write %f1  object $chr(123) Floor $chr(125)
    write %f1  object $chr(123) Spheres $chr(125)
    write %f1 // rotate -y*35
  }
  ; write %f1  $chr(125)
  run %d /RENDER  %f1
}

alias pov2txt {
  e $lines($1)
  ; %obj.tv = -1.79 -335.77 -40.25
  %obj.tv = 3.5767 -219.52145 -260.30575
  var %tv = 0.0 0.0 0.0
  %tv = %obj.tv
  var %rf = $1, %x, %y, %z, %nn, %j, %k, %idx, %face, %pr
  var %pf = $gettok($nopath(%rf),1,46) $+ _pnt.txt
  var %ff = $gettok($nopath(%rf),1,46) $+ _fce.txt
  write -c %pf | write -c %ff
  var %i = 1, %n = $lines(%rf), %w = *smooth_triangle*, %w2 = *triangle*
  var %r = $read(%rf,n,%i)
  while (%i <= %n) {
    %r = $read(%rf,n,%i)
    if (%w2 iswm %r) {
      %r = $gettok($gettok(%r,2,123),1,125)
      %r = $remove(%r,$chr(44),<,>)
      ; e $gettok(%r,1-9,32)
      %x = $gettok(%r,1-3,32)
      %y = $gettok(%r,7-9,32)
      %z = $gettok(%r,13-15,32)
      %x = $+(%x,:,%y,:,%z)
      %j = 0 | %face = $null
      while (%j <  3) {
        inc %j
        %z = $gettok(%x,%j,58)
        %z = $poptmatrix(%z,-1.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0)
        %z = $_vrnd(4,$subv(%z,%tv))
        %z = $reversey(%z)
        %k = 0
        %nn = $lines(%pf)
        %idx = %nn + 1
        while (%k < %nn) {
          inc %k
          %pr = $read(%pf,n,%k)
          if (%pr == %z) { %idx = %k | %k = %nn }
        }
        %face = %face %idx
        if (%idx == $calc(%nn + 1)) write %pf %z
      }
      write %ff %face
    }
    inc %i
    if (!$calc(%i % 10)) e %i
  }
  e $lines(%pf) pnts : $lines(%ff) faces
}
alias findcenter {
  var %rp = pnt.txt
  if ($1) %rp = $1
  var %i = 0, %p, %mx = -999999999999999, %nx = 999999999999999
  var %my = -999999999999999, %ny = 999999999999999
  var %mz = -999999999999999, %nz = 999999999999999
  var %n = $lines(%rp)
  while (%i < %n) {
    inc %i
    ; if ($calc(%i % 10) == 0) _e %i of %n
    %p = $read(%rp,n,%i)
    ; %p = $poptmatrix(%p,%obj0matrix)
    tokenize 32 %p
    if ($1 > %mx) %mx = $1
    if ($1 < %nx) %nx = $1
    if ($2 > %my) %my = $2
    if ($2 < %ny) %ny = $2
    if ($3 > %mz) %mz = $3
    if ($3 < %nz) %nz = $3
  }
  if ($prop == w) return $calc(%mx - %nx)
  if ($prop == h) return $calc(%my - %ny)
  if ($prop == d) return $calc(%mz - %nz)
  ; _e %mx %nx %my %ny %mz %nz
  _e   CenterX CenterY CenterZ LengthX LengthY LengthZ
  _e $_pad($calc(%nx + ((%mx - %nx) / 2)),7,0) $_pad($calc(%ny + ((%my - %ny) / 2)),7,0) $&
    $_pad($calc(%nz  + ((%mz - %nz) / 2)),7,0) $&
    $_pad($calc(%mx - %nx),7,0) $_pad($calc(%my - %ny),7,0) $_pad($calc(%mz - %nz),7,0)
  return $calc(%nx + ((%mx - %nx) / 2)) $calc(%ny + ((%my - %ny) / 2)) $calc(%nz  + ((%mz - %nz) / 2))
}
alias pov_2_txt {
  ; (pov-file) in mircdir
  e $lines($1)
  %obj.tv = 3.5767 -219.52145 -260.30575
  var %tv = 0.0 0.0 0.0
  %tv = %obj.tv
  var %rf = $1, %x, %y, %z, %nn, %j, %k, %idx, %face, %pr
  var %pf = $gettok(%rf,1,46) $+ _pnt.txt
  var %ff = $gettok(%rf,1,46) $+ _fce.txt
  if ($fopen(pnt)) fclose pnt | if ($fopen(fce)) fclose fce
  if ($fopen(povfile)) fclose povfile
  fopen -o pnt %pf
  fopen -o fce %ff
  var %i = 1, %n = $lines(%rf), %w = *smooth_triangle*, %w2 = *triangle*
  fopen povfile %rf 
  var %r = $fread(povfile)
  while (%i <= %n) {
    .fseek -l povfile %i
    %r = $fread(povfile)
    if (%w2 iswm %r) {
      %r = $gettok($gettok(%r,2,123),1,125)
      %r = $remove(%r,$chr(44),<,>)
      %x = $gettok(%r,1-3,32)
      %y = $gettok(%r,7-9,32)
      %z = $gettok(%r,13-15,32)
      %x = $+(%x,:,%y,:,%z)
      %j = 0 | %face = $null
      while (%j <  3) {
        inc %j
        %z = $gettok(%x,%j,58)
        %z = $poptmatrix(%z,-1.0 0.0 0.0 0.0 0.0 1.0 0.0 1.0 0.0)
        %z = $_vrnd(4,$subv(%z,%tv))
        %z = $reversey(%z)
        %k = 0
        %nn = $lines(%pf)
        ; _e %nn
        %idx = %nn + 1
        while (%k < %nn) {
          inc %k
          .fseek -l povfile %k
          %pr = $fread(pnt)
          if (!%pr) { e %k %i | halt }
          e %pr == %z
          if (%pr == %z) { e yes | %idx = %k | %k = %nn }
        }
        %face = %face %idx
        if (%idx == $calc(%nn + 1)) .fwrite pnt %z $cr
      }
      .fwrite fce %face $cr
    }
    inc %i
    if (!$calc(%i % 10)) e %i of %n
  }
  fclose pnt | fclose fce | fclose povfile
  e $lines(%pf) pnts : $lines(%ff) faces
}
alias reversey {
  ; (v)
  ; reverse y
  tokenize 32 $1-
  return $1 $lmult(-1,$2) $3
}
alias removetags {
  var %f = edit.txt, %n = $lines(%f), %i = 0, %j, %c, %tagflag = 0, %line, %r
  while (%i < %n) {
    inc %i
    %r = $read(%f,n,%i)
    %j = 0
    if (%r) {
      while (%j < $len(%r)) {
        inc %j
        %c = $mid(%r,%j,1)
        if (%c == <) %tagflag = 1
        if (%c == >) %tagflag = 0
        if ((!%tagflag) && (%c != >)) {
          if (%c == $chr(32)) %line = %line $+ $chr(160)
          else %line = %line $+ %c
        }
      }
      e $replace(%line,$chr(160),$chr(32))
      %line = $null
    }
  }
}
alias planarmapping {
  ; (pnt_file).x .y .z axis plane
  var %rp = pnt.txt
  if ($1) %rp = $1
  var %i = 0, %p, %mx = -999999999999999, %nx = 999999999999999
  var %my = -999999999999999, %ny = 999999999999999
  var %mz = -999999999999999, %nz = 999999999999999
  var %n = $lines(%rp)
  while (%i < %n) {
    inc %i
    ; if ($calc(%i % 10) == 0) _e %i of %n
    %p = $read(%rp,n,%i)
    ; %p = $poptmatrix(%p,%obj0matrix)
    tokenize 32 %p
    if ($1 > %mx) %mx = $1
    if ($1 < %nx) %nx = $1
    if ($2 > %my) %my = $2
    if ($2 < %ny) %ny = $2
    if ($3 > %mz) %mz = $3
    if ($3 < %nz) %nz = $3
  }
  if ($prop == w) return $calc(%mx - %nx)
  if ($prop == h) return $calc(%my - %ny)
  if ($prop == d) return $calc(%mz - %nz)
  ; _e %mx %nx %my %ny %mz %nz
  ; var %cx = $calc(%nx + ((%mx - %nx) / 2)), %cy = $calc(%ny + ((%my - %ny) / 2))
  ; var %cz = $calc(%nz  + ((%mz - %nz) / 2))
  var %lx = $calc(%mx - %nx), %ly = $calc(%my - %ny), %lz = $calc(%mz - %nz)
  if ($prop == x) return %lz %ly 1.0 0 90 0 %nx %ny %nz
  if ($prop == y) return %lx %lz 1.0 90 0 0 %nx %ny %nz
  if ($prop == z) return %lx %ly 1.0 0 0 0 %nx %ny %nz
  ;      com file suf type amb spec diff sizev rotv  transv
  ; //e map warpl png 0 0.85 0.3 0.1 $planarmapping(warp_lpnt.txt).x
  ; planar mapping values
}
alias planarmapping2 {
  ; (pov,obj).x .y .z axis plane
  var %f = $1
  var %w = $+(//*,$2,*)
  var %r = $read(%f,nw,%w)
  tokenize 32 $gettok(%r,3-8,32)

  if ($prop == w) return $4
  if ($prop == h) return $5
  if ($prop == d) return $6
  var %nx = $calc($1 - ($4 / 2))
  var %ny = $calc($2 - ($5 / 2))
  var %nz = $calc($2 - ($6 / 2))

  if ($prop == x) return $6 $5 1.0 0 90 0 %nx %ny %nz
  if ($prop == y) return $4 $6 1.0 90 0 0 %nx %ny %nz
  if ($prop == z) return $4 $5 1.0 0 0 0 %nx %ny %nz

}
