alias Floorchkr {
  write $1 #declare Floorchkr =
  write $1 plane $chr(123) y, $did(mbuild,550)
  write $1 pigment $chr(123)
  write $1 checker rgb 1, rgb .5
  write $1 scale 7
  write $1 rotate <0, 40, 0>
  write $1 $chr(125)
  write $1 finish $chr(123)
  write $1 ambient 0.5
  write $1 diffuse 0.3
  write $1 $chr(125)
  write $1 $chr(125)
}
alias Floor1 {
  write $1 #declare Floor1 =
  write $1 plane $chr(123) z, $did(mbuild,550)
  write $1 texture $chr(123) T_Chrome_2C
  write $1 $chr(125)
  write $1 finish $chr(123)
  write $1 ambient 0.2
  write $1 diffuse 0.8
  write $1 $chr(125)
  write $1 $chr(125)
}
alias fl_blue {
  write $1 #declare fl_blue =
  write $1 plane $chr(123)
  write $1 y, $did(mbuild,550)
  write $1 texture $chr(123)
  write $1 pigment $chr(123)
  write $1 bozo
  write $1 color_map $chr(123)
  write $1 [[ 0.0 color rgb<0.321, 0.274, 0.356> ]]
  write $1 [[ 0.1 color rgb<0.500, 0.500, 0.611> ]]
  write $1 [[ 0.4 color rgb<0.623, 0.623, 0.745> ]]
  write $1 [[ 1.0 color rgb<0.782, 0.745, 0.837> ]]
  write $1 $chr(125)
  write $1 warp $chr(123) turbulence 0.6 $chr(125)
  write $1 $chr(125)
  write $1 finish $chr(123)
  write $1 diffuse 0.6
  write $1 ambient 0.25
  write $1 specular 0.1
  write $1 conserve_energy
  write $1 $chr(125)
  write $1 $chr(125)
  write $1 $chr(125)
}
alias fl_red {
  write $1 #declare fl_red =
  write $1 plane $chr(123)
  write $1 y, $did(mbuild,550)
  write $1 texture $chr(123)
  write $1 pigment $chr(123)
  write $1 bozo
  write $1 color_map $chr(123)
  write $1 [[ 0.0 color rgb<0.356, 0.321, 0.274> ]]
  write $1 [[ 0.1 color rgb<0.611, 0.500, 0.500> ]]
  write $1 [[ 0.4 color rgb<0.745, 0.623, 0.623> ]]
  write $1 [[ 1.0 color rgb<0.837, 0.782, 0.745> ]]
  write $1 $chr(125)
  write $1 warp $chr(123) turbulence 0.6 $chr(125)
  write $1 $chr(125)
  write $1 finish $chr(123)
  write $1 diffuse 0.6
  write $1 ambient 0.1
  write $1 specular 0.2
  write $1 reflection $chr(123)
  write $1 0.2, 0.6
  write $1 fresnel on
  write $1 $chr(125)
  write $1 conserve_energy
  write $1 $chr(125)
  write $1 $chr(125)
  write $1 $chr(125)
}
alias fl_green {
  write $1 #declare fl_green =
  write $1 plane $chr(123)
  write $1 y, $did(mbuild,550)
  write $1 texture $chr(123)
  write $1 pigment $chr(123)
  write $1 bozo
  write $1 color_map $chr(123)
  write $1 // greenish more detail
  write $1 [[ 0.0 color rgb<0.321, 0.356, 0.274> ]]
  write $1 [[ 0.1 color rgb<0.500, 0.611, 0.500> ]]
  write $1 [[ 0.4 color rgb<0.623, 0.745, 0.623> ]]
  write $1 [[ 1.0 color rgb<0.782, 0.837, 0.745> ]]
  write $1 $chr(125)
  write $1 warp $chr(123) turbulence 0.6 $chr(125)
  write $1 $chr(125)
  write $1 finish $chr(123)
  write $1 diffuse 0.6
  write $1 ambient 0.25
  write $1 specular 0.1
  write $1 conserve_energy
  write $1 $chr(125)
  write $1 $chr(125)
  write $1 $chr(125)
}
alias fl_Oaklight fl_wood $1 fl_Oaklight wood-22_d
alias fl_Oakdark fl_wood $1 fl_Oakdark wood-28_d
alias fl_Merbau fl_wood $1 fl_Merbau wood-33_d
alias fl_Maple fl_wood $1 fl_Maple wood-08_d
alias fl_Maplered fl_wood $1 fl_Maplered wood-10_d
alias fl_Cherry fl_wood $1 fl_Cherry wood-32_d
alias fl_wood {
  write $1 #declare $2 =
  write $1 plane $chr(123) y, $did(mbuild,550)
  write $1 texture $chr(123)
  write $1 pigment $chr(123) image_map $chr(123) png $+(",$3,") $chr(125) $chr(125)
  write $1 finish $chr(123)
  write $1 ambient 0
  write $1 brilliance 2
  write $1 diffuse 0.7
  ; metallic
  write $1 specular 0.4
  write $1 roughness 1/12
  write $1 reflection 0.01
  write $1 $chr(125)
  write $1 translate < -0.5 , -0.5, 0.0 >
  write $1 scale < 66.0 , 99.0 , 1.0 >
  write $1 rotate < 90 , 0 , 0 >
  write $1 $chr(125)
  write $1 $chr(125)
}
alias floor_writer {
  if ($did(mbuild,506).seltext) {
    var %c = $did(mbuild,506).seltext
    %c $1
    if (%c) write $1 object $chr(123) %c $chr(125)
  }
}
alias sky_writer {
  var %s = $did(mbuild,508).seltext
  if ($left(%s,4) == sky_) write $1 sky_sphere $chr(123) %s $chr(125)
  else {
    var %c = $povcolorv(%s)
    if (%s)  {
      write $1 #declare $+(sky_,%s) =
      write $1 sky_sphere $chr(123)
      write $1 pigment $chr(123)
      write $1 gradient y
      write $1 color_map $chr(123)
      write $1 [0.0 rgb < $spcm(%c) >]
      write $1 [1.0 rgb < $spcm($multv(%c,0.2)) >]
      write $1 $chr(125)
      write $1 $chr(125)
      write $1 $chr(125)
      write $1 sky_sphere $chr(123) $+(sky_,%s) $chr(125)
    }
  }
}
alias fl_chrome1c {
  write $1 #declare fl_chrome1c =
  write $1 plane $chr(123) y, $did(mbuild,550) texture $chr(123) T_Chrome_1C $chr(125)
  write $1 $chr(125)
}
alias fl_chrome2c {
  write $1 #declare fl_chrome2c =
  write $1 plane $chr(123) y, $did(mbuild,550) texture $chr(123) T_Chrome_2C $chr(125)
  write $1 $chr(125)
}
alias fl_chrome3c {
  write $1 #declare fl_chrome3c =
  write $1 plane $chr(123) y, $did(mbuild,550) texture $chr(123) T_Chrome_3C $chr(125)
  write $1 $chr(125)
}
alias fl_chrome4c {
  write $1 #declare fl_chrome4c =
  write $1 plane $chr(123) y, $did(mbuild,550) texture $chr(123) T_Chrome_4C $chr(125)
  write $1 $chr(125)
}
alias fl_chrome5c {
  write $1 #declare fl_chrome5c =
  write $1 plane $chr(123) y, $did(mbuild,550) texture $chr(123) T_Chrome_5C $chr(125)
  write $1 $chr(125)
}
; IOR as a function of time.
interior {
  ior 1.5 * clock
  dispersion 1. + (0.1 * clock)
}
; where clock goes from zero to one.
alias woods { 

  04 bamboo
  08 greenish maple
  10 maple
  22 oak
  28 oak
  32 cherry
  33 Merbau

}
alias 3dslimits {
  #  All meshes must be triangles.
  # All texture filenames are limited to 8.3 DOS character lengths.
  # The number of vertices and polygons per mesh is limited to 65536.
  # Accurate vertex normals cannot be stored in the .3ds file. Instead "smoothing groups"
  are used so that the receiving program can recreate a (hopefully good) representation 
  of the vertex normals. This is still a hold-over legacy for many animation programs today 
  which started in the 1980's (3DS MAX, Lightwave and trueSpace still use smoothing groups, 
  and Maya up to v2.51).
  # Object, light and camera names are limited to 10 characters. Material names are limited to 16 characters.
  # Directional light sources are not supported.
}
alias cropim {
  var %i = 0, %f, %wn = %br.wn, %wh = 600 270, %final =  512 230
  %wn = @copy
  var %pf = $+($mircdir,creation\m31_andromeda.png)
  window -fdp %wn 0 0 %final
  drawrect -nf %wn 1 1 0 0 %final
  drawpic -ns %wn 0 0 512 100 0 0 1100 200 %pf
  drawdot %wn
  var %s = %wn 1 1 0 0 %final * %wn 0 0 512 120 0 0 1100 280 %pf * %wn 0 0 0 %final 15 0 %wh
  ;  frame1 %s
  timer.an -m 99 150 frame1 %wn 1 1 0 0 %final * %wn 0 0 512 120 0 0 1100 280 %pf * %wn 0 0 0 %final 15 0 %wh
}
alias frame1 {
  tokenize 42 $1-
  var  %final =  512 230
  ; e $abs($calc($timer(.an).reps - 99))
  var %i = $abs($calc($timer(.an).reps - 99))
  if (%i !isnum 1-99) %i = 50
  var %f = $+(ballroll2,$pad(%i,2,0),.bmp)
  drawrect -nf $1
  drawpic -ns $2
  drawpic -nts $3 %f
  drawdot @copy
  drawsave @copy $+(ballroll_02,$pad(%i,2,0),.bmp)
}
alias 025 {
  var %i = 0, %tc
  while (%i < %PI.5) {
    inc %i 0.01

    ;  e $cos(%i)
    %tc = %i / %PI.5
    ;
    ; e %tc
    ; e $clamp($calc(%tc - 0.75),0,0.25)


    e $calc($abs($calc($cos($calc($clamp($calc(%tc - 0.75),0,0.25) * 2 * %PI)) - 1)) * 90)

  }

}



alias this {
  while (%i < 99) {
    inc %i
    %f = $+(ballroll2,$pad(%i,2,0),.bmp)
    drawrect -nf %wn 1 1 0 0 %final
    drawpic -ns %wn 0 0 512 100 0 0 1100 270 %pf
    drawpic -nts %wn 0 0 0 %final 15 0 %wh %f
    ; drawsave %wn $+(ballroll_02,$pad(%i,2,0),.bmp)
    if (%i == 99) %i = 0
    drawdot %wn
  }
}



alias cropim2 {
  var %i = 0, %f, %wn = %br.wn, %wh = 140 60, %final = 140 60
  %wn = @copy
  var %pf = $+($mircdir,creation\m31_andromeda.png)
  window -fdp %wn 0 0 %final
  drawrect -nf %wn 1 1 0 0 %final
  drawpic -ns %wn 0 0 140 30 0 0 1100 200 %pf
  drawdot %wn
  var %s = %wn 1 1 0 0 %final * %wn 0 0 512 120 0 0 1100 280 %pf * %wn 0 0 0 %final 10 0 %wh
  ;  frame1 %s
  timer.an -m 99 150 frame2 %wn 1 1 0 0 %final * %wn 0 0 140 30 0 0 1100 280 %pf * %wn 0 0 0 %final 10 0 %wh
}
alias frame2 {
  tokenize 42 $1-
  var  %final =  140 60
  ; e $abs($calc($timer(.an).reps - 99))
  var %i = $abs($calc($timer(.an).reps - 99))
  if (%i !isnum 1-99) %i = 50
  var %f = $+(c:\viaudio\ballroll2,$pad(%i,2,0),.bmp)
  drawrect -nf $1
  ; drawpic -ns $2
  drawpic -nts $3 %f
  drawdot @copy
  drawsave @copy $+(c:\viaudio\ballroll_02,$pad(%i,2,0),.bmp)
}




alias cropim3 {
  var %i = 0, %f, %wn = %br.wn, %wh = 300 170, %final = 300 170
  %wn = @copy
  var %pf = $+($mircdir,creation\m31_andromeda.png)
  window -fdp %wn 0 0 %final
  drawrect -nf %wn 1 1 0 0 %final
  drawpic -ns %wn 0 0 140 30 0 0 1100 200 %pf
  drawdot %wn
  var %s = %wn 1 1 0 0 %final * %wn 0 0 512 120 0 0 1100 280 %pf * %wn 0 0 0 %final 10 0 %wh
  ;  frame1 %s
  timer.an -m 99 150 frame3 %wn 1 1 0 0 %final * %wn 0 0 140 30 0 0 1100 280 %pf * %wn 0 0 0 %final 10 0 %wh
}
alias frame3 {
  tokenize 42 $1-
  var  %final =  300 170
  ; e $abs($calc($timer(.an).reps - 99))
  var %i = $abs($calc($timer(.an).reps - 99))
  if (%i !isnum 1-99) %i = 50
  var %f = $+(c:\viaudio\ballroll4,$pad(%i,2,0),.bmp)
  drawrect -nf $1
  ; drawpic -ns $2
  drawpic -nts $3 %f
  drawdot @copy
  drawsave @copy $+(c:\viaudio\ballroll_04,$pad(%i,2,0),.bmp)
}


alias cropim4 {
  var %i = 0, %f, %wn = %br.wn, %wh = 480 200, %final = 480 200
  %wn = @copy
  var %pf = $+($mircdir,creation\m31_andromeda.png)
  window -fdp %wn 0 0 %final
  drawrect -nf %wn 1 1 0 0 %final
  drawpic -ns %wn 0 0 480 110 0 0 1100 280 %pf
  drawdot %wn

  var %s = %wn 1 1 0 0 %final * %wn 0 0 480 110 550 0 550 120 %pf * %wn 0 0 0 %final 16 0 %wh
  ; 0 0 1100 280
  ;  frame4 %s
  timer.an -m 99 150 frame4 %s
}
alias frame4 {
  tokenize 42 $1-
  var  %final =  480 200
  ; e $abs($calc($timer(.an).reps - 99))
  var %i = $abs($calc($timer(.an).reps - 99))
  if (%i !isnum 1-99) %i = 50
  var %f = $+(c:\viaudio\ballroll2,$pad(%i,2,0),.bmp)
  drawrect -nf $1
  drawpic -ns $2
  drawpic -nts $3 %f
  drawdot @copy
  drawsave @copy $+(c:\viaudio\ballroll_02,$pad(%i,2,0),.bmp)
}


alias cropim5 {
  var %i = 0, %f, %wn = %br.wn, %wh = 500 300, %final = 250 150
  %wn = @copy
  var %pf = $+($mircdir,creation\m31_andromeda.png)
  window -fdp %wn 0 0 %final
  drawrect -nf %wn 1 1 0 0 %final
  drawpic -ns %wn 0 0 480 110 0 0 1100 280 %pf
  drawdot %wn

  var %s = %wn 1 1 0 0 %final * %wn 0 0 250 50 550 0 550 120 %pf * %wn 0 0 0 %final 65 60 %wh
  ; 0 0 1100 280
  ;  frame5 %s
  timer.an -m 99 150 frame5 %s
}
alias frame5 {
  tokenize 42 $1-
  var  %final = 250 150
  ; e $abs($calc($timer(.an).reps - 99))
  var %i = $abs($calc($timer(.an).reps - 99))
  if (%i !isnum 1-99) %i = 50
  var %f = $+(c:\viaudio\ballroll4,$pad(%i,2,0),.bmp)
  drawrect -nf $1
  ; drawpic -ns $2
  drawpic -nts $3 %f
  drawdot @copy
  drawsave @copy $+(c:\viaudio\ballroll_05,$pad(%i,2,0),.bmp)
}


alias cropim6 {
  var %i = 0, %f, %wn = %br.wn, %wh = 420 300, %final = 210 150
  %wn = @copy
  var %pf = $+($mircdir,creation\m31_andromeda.png)
  window -fdp %wn 0 0 %final
  drawrect -nf %wn 1 1 0 0 %final
  ; drawpic -ns %wn 0 0 210 50 0 0 1100 280 %pf
  drawdot %wn

  var %s = %wn 1 1 0 0 %final * %wn 0 0 210 50 550 0 550 120 %pf * %wn 0 0 0 %final 145 60 %wh
  ; 0 0 1100 280
  ;  frame6 %s
  timer.an -m 99 150 frame6 %s
}
alias frame6 {
  tokenize 42 $1-
  var  %final = 210 150
  ; e $abs($calc($timer(.an).reps - 99))
  var %i = $abs($calc($timer(.an).reps - 99))
  if (%i !isnum 1-99) %i = 50
  var %f = $+(c:\viaudio\ballroll5,$pad(%i,2,0),.bmp)
  drawrect -nf $1
  ; drawpic -ns $2
  drawpic -nts $3 %f
  drawdot @copy
  drawsave @copy $+(c:\viaudio\ballroll_06,$pad(%i,2,0),.bmp)
}







alias pulse {
  ; pulseline(bluep,0.1,p*7,p*40,1,0.1)
  var %p = $normalize(1 1 0)
  var %v = $pulseline(4,0.1,$multv(%p,7),$multv(%p,400),50,0.01)
}

alias pulseline {
  ; (col,spaceing,pos1,pos2,amp,freq)
  var %spacing = $2, %len = $vlen($subv($4,$3))
  var %i = 1, %pos = $1, %perp1, %perp2
  var %n = $vlen($divv($subv($4,$5),%spacing))
  while (%i < %n) {
    ;          pos2-pos1)/spaceing)
    ;         loop for 330. mult vector by iterator 1-330  (329)
    ;         div the vector (of len 33-330) by 330
    ;         and add back to startingpos = pos
    %pos = $addv($3, $divv($multv($subv($4,$3),%i),$calc(%len / %spacing)))
    %perp1 = $normalize($VPerp_To_Vector(%pos))
    %perp2 = $normalize($cross(%pos,%perp1))
    ;         e %perp1 %perp2
    ;        complete to 2 perp vectotrs to current position for sin1 cos2
    ;        -.5 to .5  + 1 = rand(.5 thru 1.5) times len current position
    ;        divided by 33 (overall len)  =  locamp
    %perturb = $calc($r(0,20000) / 20000 - 0.5)
    ; SRand(stream4)/2;
    %locamp = $calc((%perturb + $5) * $vlen(%pos) / %len)
    ;       locamp times the normalized perp vectors
    ;       times sin/cos of fullcircle radians (pi2) *.1* len of curr pos

    %pos = $addv(%pos,$addv( $&
      $multv(%perp1,$calc(%locamp * $sin($calc(%PI2 * $6 * $vlen(%pos))))), $&
      $multv(%perp2,$calc(%locamp * $cos($calc(%PI2 * $6 * $vlen(%pos)))))))

    ; %pos = $addv2i(%drw.cen.x %drw.cen.y,%pos)
    %pos = $addv2i(0 0,%pos)
    drawdot %drw.win 4 1 %pos
    inc %i
  }
  return %pos
}

alias VPerp_To_Vector {
  var %Dm, %vN
  tokenize 32 $1-
  if ($vlen($1-) == 0.0) %vN = 0 0 0
  else %Dm = $min($abs($1), $abs($2), $abs($3))
  if ($abs($3) == %Dm) %vN = $normalize($cross($1-,0 0 1))
  else if ($abs($2) == %Dm) %vN = $normalize($cross($1-,0 1 0))
  else %vN = $normalize($cross($1-,1 0 0))
  return %vN
}
alias min {
  var %i = 2, %n, %result = $1
  while (%i <= $0) {
    %n = $gettok($1-,%i,32)
    if (%n < %result) %result = %n
    inc %i
  }
  return %result
}






alias cropim7 {
  var %i = 0, %f, %wn = %br.wn, %wh = 240 240, %final = 240 240
  %wn = @copy
  var %pf = $+($mircdir,creation\m31_andromeda.png)
  window -fdp %wn 0 0 %final
  drawrect -nf %wn 1 1 0 0 %final
  ; drawpic -ns %wn 0 0 140 30 0 0 1100 200 %pf
  drawdot %wn
  ; var %s = %wn 1 1 0 0 %final * %wn 0 0 512 120 0 0 1100 280 %pf * %wn 0 0 0 %final 40 0 %wh
  ;  frame1 %s
  timer.an -m 30 150 frame7 %wn 1 1 0 0 %final * %wn 0 0 140 30 0 0 1100 280 %pf * %wn 0 0 0 %final 40 0 %wh
}
alias frame7 {
  var %nfs = 30
  tokenize 42 $1-
  var  %final =  240 240
  ; e $abs($calc($timer(.an).reps - %nfs))
  var %i = $abs($calc($timer(.an).reps - %nfs))
  if (%i !isnum 1- %nfs) %i = %nfs
  var %f = $+(c:\viaudio\smooth_dodec846ca,$pad(%i,2,0),.bmp)
  drawrect -nf $1
  ; drawpic -ns $2
  drawpic -nts $3 %f
  drawdot @copy
  drawsave @copy $+(c:\viaudio\smooth_dodec_anim,$pad(%i,2,0),.bmp)
}
