alias go3all {
  draw_range 9 2 $did(mbuild,6)
  draw_range 9 2 $did(mbuild,7)
  draw_range_x 0 2 $did(mbuild,8)
  drawdot %drw.win
  ; $did(mbuild,%clk.cap)
}
alias view_edits {
  drawbg 1
  if (%drw.edmode == 3) drawe_range 7 2 $did(mbuild,9)
  else {
    drawe_range 13 2 $did(mbuild,6)
    drawe_range 13 2 $did(mbuild,7)
    drawe_range_x 0 2 $did(mbuild,8)
  }
  drawdot %drw.win
}
alias addquads {
  %drw.stripcolor = 11651057
  write -c autoface.txt
  ; unset %pnt2_*
  var %f, %i = 0, %p, %j = 21, %cp, %ht, %hb, %wo, %wi, %r, %h, %w, %o = 0
  var %k = 21, %l = 20, %m = 40, %n = 1, %segs, %cp, %rows
  tokenize 32 $did(mbuild,6)
  %n = $1 | %l = $2
  tokenize 32 $did(mbuild,7)
  %k = $1 | %m = $2
  tokenize 32 $did(mbuild,8)
  %j = $1 | %rows  = $2
  %cp = %axis_ [ $+ [ %j ] ]
  %drw.cenp = %cp
  %cp = $doubletcast(%cp)

  %segs = $did(mbuild,330)
  %nfaces = 0
  var %s1 = 1, %s2 = 0, %e1 = 1, %e2 = 0

  %rows = 12
  ; for test

  while (%i < %rows) {
    inc %i
    if (%i <= %rows) {
      ; outside
      %wo = %pnt_ [ $+ [ %k ] ] 
      ; top
      %ht = %pnt_ [ $+ [ %l ] ] 
      ; inside
      %wi = %pnt_ [ $+ [ %m ] ] 
      ; bottom
      %hb = %pnt_ [ $+ [ %n ] ] 

      %cp = %axis_ [ $+ [ %j ] ]
      %drw.cenp = %cp
      %cp = $doubletcast(%cp)
      inc %j
      inc %k
      dec %l
      dec %m
      inc %n

      %r = $calc($radian(%ht,%hb,$addv(%ht,0.0 1.0 0.0)) * 1)
      %drw.matrix = 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0
      %camrotv = 0 %PI.5 0
      %drw.matrix = $gimbalmatrix(%drw.matrix)
      %camrotv = 0 0 %r
      %drw.matrix = $gimbalmatrix(%drw.matrix)

      %wo = $vlen($subv(%wo,%cp))
      %ht = $vlen($subv(%ht,%cp))
      %wi = $vlen($subv(%wi,%cp))
      %hb = $vlen($subv(%hb,%cp))
    }
    if (0) {
      ; (quad, w, h, npnts per quad, direction 1 or -1, last-pointer-used, add/flatten)
    }
    else {
      ; e %s1 %s2 %e1 %e2
      %s1 = %s2
      %s2 = %o
      ; ---> Memory to %pnt2_*
      if (%i <= 10) {
        quadelip2 1 %wo %ht %segs 1 %o 0
        inc %o %segs
        quadelip2 2 %wo %hb %segs 1 %o 0
        inc %o %segs
        quadelip2 3 %wi %hb %segs 1 %o 0
        inc %o %segs
        quadelip2 4 %wi %ht %segs 1 %o 0
        inc %o %segs
      }
      else inc %o 8
      %e1 = %e2 
      %e2 = %o
      ; e %s1 %s2 %e1 %e2
      inc %s2
      if (%e2 > 160) %drw.stripcolor = 7638477
      if ((%s1) && (%i <= %rows)) stripfaces %s1 %e1 %s2 %e2
      ; stripfaces connects strip ends, unconnected is
      ; triangulate_face2 $string_range(%s1,%e1) $string_range(%e2,%s2)
    }
  }
  if (10) {
    %f = %drw.fce.file
    %drw.fce.file = autoface.txt
    ; triangulate_face 169 170 171 172 173 174 175 176
    ; triangulate_face 176 175 174 173 172 171 170 169
    triangulate_face2 $string_range(169,176)
    ; copy -o %drw.fce.file %f
    %drw.fce.file = %f
  }
  %nfaces = $lines(autoface.txt)
  echo -s %nfaces Faces
  %drw.pni = %o
  did -o mbuild 329 1 %drw.pni
}
alias stripfaces {
  ; (range1 range2) exact
  ; echo 4 actual: $1-
  ;  e **********************************************
  if (1) {
    var %a = $calc($2 - ($1 - 1))
    ; if (%a <= 0) %a = 0
    var %b = $calc($4 - ($3 - 1))
    if (%b < 1) %b = 1
    var %i = -1, %j = 0
    ; %n = %a + %b -- n != nfaces
    var %k = $1, %last, %ratio
    if (%a < 1) %a = 1
    if (%a <= %b) {
      ; odd stacks makes them equal - missed face
      if (%a == %b) outfil $1 $calc($1 + 1) $3
      %ratio = %a / %b
      inc %k %ratio
      :loop | inc %i | inc %j
      outfil $calc(%i + $3) $int(%k) $calc(%j + $3)
      %last = $calc($int(%k) + 1)
      if (%last > $2) %last = $1
      if (%k < $2) {
        if ($int($calc(%k + %ratio)) > $int(%k)) outfil $calc(%j + $3) $int(%k) %last
        inc %k %ratio
      }
      if ($calc(%j + $3) < $4) goto loop
      if ($2 != $1) outfil $4 $2 $1
      outfil $3 $4 $1
    }
    else if (1) {
      %k = $3
      %ratio = %b / %a
      inc %k %ratio
      :loop3 | inc %i | inc %j
      outfil $calc(%i + $1) $calc(%j + $1) $int(%k)
      %last = $calc($int(%k) + 1)
      if (%last > $4) %last = $3
      if (%k < $4) {
        if ($int($calc(%k + %ratio)) > $int(%k)) outfil $calc(%j + $1) %last $int(%k)
        inc %k %ratio
      }
      if ($calc(%j + $1) < $2) goto loop3
      if ($3 != $4) outfil $2 $3 $4
      outfil $1 $3 $2
    }
    ; %nfaces = $line(@sort,0)
  }
}
alias outfil {
  ; echo -s $1-
  if (0) {
    ; reverse norms
    tokenize 32 $1-
    tokenize 32 $3 $2 $1 $4
  }
  write autoface.txt $1- %drw.stripcolor
  ; if (%nfaces < 288) write autoface.txt $1- %drw.stripcolor
  ; else write autoface.txt $1- %drw.stripcolor
  inc %nfaces
}
alias mem_save {
  mem_save2 $did(mbuild,6)
  mem_save2 $did(mbuild,7)
  mem_sav_ax $did(mbuild,8)
}
alias mem_save2 {
  ; (range)
  var %i = $1, %p
  dec %i
  while (%i < $2) {
    inc %i
    %p = %edit_ [ $+ [ %i ] ]
    drawdot %drw.win 13 2 %p
    ; check without saving first
    %pnt_ [ $+ [ %i ] ] = $vrnd6(%p)
  }
  e edit saved
}
alias mem_sav_ax {
  ; (range)
  var %i = $1, %p
  dec %i
  while (%i < $2) {
    inc %i
    %p = %editaxis_ [ $+ [ %i ] ]
    drawdot %drw.win 13 2 %p
    ; check without saving first
    %axis_ [ $+ [ %i ] ] = $vrnd6(%p)
  }
  e edit saved
}
alias save_edit {
  ; (Filename) pnt2_* -> file
  var %n = 0, %f, %i = 0, %p, %q =1
  if (!$1) {
    if ($did(mbuild,300).lines) %n = $did(mbuild,300).lines
    tokenize 32 $did(mbuild,300).text
    if ($1) {
      %f = $+($1,pnt.txt)
      if ($not_there($1,%n,300)) did -o mbuild 300 $calc(%n + 1) $1
    }
    else {
      %f = $$?="Enter filename for %drw.pni pnts"
      ; e $not_there(%f,%n,300)
      if ($not_there(%f,%n,300)) did -o mbuild 300 $calc(%n + 1) %f
      %f = $+(%f,pnt.txt)
    }
  }
  else if ($1) %f = $+($1,pnt.txt)
  if (%f) {
    if ($exists(%f)) %q = $?!="Overwrite %f with %drw.pni pnts ?"
    if (%q) {
      write -c %f
      while (%i < %drw.pni) {
        inc %i
        %p = %pnt2_ [ $+ [ %i ] ]
        drawdot %drw.win 9 2 %p
        write %f %p
      }
    }
  }
  %f = $+($left(%f,-7),fce.txt)
  copy -o autoface.txt %f
}
alias not_there {
  ; (search string,n,combo id)
  var %i = 0, %t
  while (%i < $2) {
    inc %i
    %t = $did(mbuild,$3,%i).text
    if ($1 == %t) return 0
  }
  if ($1) return 1
  return 0
}
alias draw_all {
  var %i = 0, %p, %q = 0, %n = $did(mbuild,309).state
  while (%i < %drw.pni) {
    inc %i
    %p = %pnt2_ [ $+ [ %i ] ]
    drawdot %drw.win 9 2 %p
    if (%n) drawtext %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
  }
}
alias edit_obj {
  %clk.cap = $checksel
  if (!%clk.cap) { _e Select curve or axis | halt }
  if ((%drw.edmode == 2) || (!%drw.edmode)) {
    %drw.edmode = 1
    did -o mbuild 321 1 Click Mode
    did -b mbuild 302
    did -b mbuild 303
    did -b mbuild 304
    did -b mbuild 305
  }
  else if (%drw.edmode == 1) {
    %drw.edmode = 2
    did -o mbuild 321 1 Edit Mode
    did -e mbuild 302
    did -e mbuild 303
    did -e mbuild 304
    did -e mbuild 305
  }
  var %r = $did(mbuild,%clk.cap), %c = 9, %c2 = 0, %q
  if (%drw.edmode == 2) {
    %c = 13
  }
  if (%clk.cap isnum 6-7) {
    draw_range %c 2 %r
  }
  if (%clk.cap == 8) {
    draw_range_x %c2 2 %r
  }
  if (%drw.edmode == 2) {
    %q = $?!="Overwrite edit_*. previous edits overwritten"
    if (%q) {
      editmemory $did(mbuild,6) 6
      editmemory $did(mbuild,7) 7
      editmemory $did(mbuild,8) 8
    }
  }
  did -o mbuild 329 1 %drw.pni
  drawdot %drw.win
}
alias checksel {
  if ($did(mbuild,308).state) return 8
  if ($did(mbuild,307).state) return 7
  if ($did(mbuild,306).state) return 6
  if (%drw.edmode == 3) return 9
  return 0
}
alias checkconstr {
  if ($did(mbuild,2).state) return 2
  if ($did(mbuild,3).state) return 3
  if ($did(mbuild,4).state) return 4
  if ($did(mbuild,5).state) return 5
  return 0
}
alias draw_range {
  ; (color size range1 range2)
  var %i, %p, %n = $did(mbuild,309).state
  if ($0 == 4) {
    %i = $3 - 1
    while (%i < $4) {
      inc %i
      %p = %pnt_ [ $+ [ %i ] ]
      drawdot -n %drw.win $1 $2 %p
      if (%n) drawtext %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    }
  }
}
alias draw_range_x {
  ; e $1 $2 $3 $4
  var %i, %p, %n = $did(mbuild,309).state
  if ($0 == 4) {
    var %xy = %axis_ [ $+ [ $3 ] ] %axis_ [ $+ [ $4 ] ]
    %xy = $gettok(%xy,1-2,32) $gettok(%xy,4-5,32)
    drawline %drw.win $1 1 %xy
    %i = $3 - 1
    while (%i < $4) {
      inc %i
      %p = %axis_ [ $+ [ %i ] ]
      drawdot -n %drw.win $1 $2 %p
      ;  e $1 $2 %p
      if (%n) drawtext %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    }
  }
}
alias drawe_range {
  ; (color size range1 range2)
  var %i, %p, %n = $did(mbuild,309).state
  if (!$3) tokenize $1- 1 %drw.pni
  if ($0 == 4) {
    %i = $3 - 1
    while (%i < $4) {
      inc %i
      %p = %edit_ [ $+ [ %i ] ]
      if (0) %p = $addv(%p,%drw.cen.x,%drw.cen.y,0.0)
      drawdot -n %drw.win $1 $2 %p
      if (%n) drawtext %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    }
  }
}
alias drawe_range_x {
  ; e $1 $2 $3 $4
  var %i, %p, %n = $did(mbuild,309).state
  if ($0 == 4) {
    var %xy = %editaxis_ [ $+ [ $3 ] ] %editaxis_ [ $+ [ $4 ] ]
    %xy = $gettok(%xy,1-2,32) $gettok(%xy,4-5,32)
    drawline %drw.win $1 1 %xy
    %i = $3 - 1
    while (%i < $4) {
      inc %i
      %p = %editaxis_ [ $+ [ %i ] ]
      drawdot -n %drw.win $1 $2 %p
      ;  e $1 $2 %p
      if (%n) drawtext %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    }
  }
}
alias editmemory {
  var %i = $1, %p, %r, %num = $did(mbuild,309).state
  var %n = $int($calc($2 / 2)), %a = %pnt_ [ $+ [ %n ] ]
  inc %n
  var %b = %pnt_ [ $+ [ %n ] ]
  ; axis pnt
  %edit_0 = $midpoint(%a,%b)
  if ($calc($2 % 2)) %edit_0 = %pnt_ [ $+ [ %n ] ]
  if ($3 == 8) %edit_0 = %axis_ [ $+ [ $2 ] ]
  dec %i
  while (%i < $2) {
    inc %i
    if ($3 == 8) %p = %axis_ [ $+ [ %i ] ]
    else %p = %pnt_ [ $+ [ %i ] ]

    ; %p = $subv(%p,%edit_0)
    ; %p = $poptmatrix(%p,%drw.matrix)
    ; %p = $addv(%p,%edit_0)
    drawdot %drw.win 13 2 $addvi(%p, 0 0 0)
    if (%num) drawtext %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    if ($3 == 8) %editaxis_ [ $+ [ %i ] ] = %p
    else %edit_ [ $+ [ %i ] ] = %p
  }
}
alias clear_rng_fields {
  did -o mbuild 6 1 0
  did -o mbuild 7 1 0
  ; did -o mbuild 8 1 0
}
alias curve_cp {
  ; (field 6-7)
  var %cp = 0 0 0
  if ($1 == 9) return %drw.cen.x %drw.cen.y 0.0
  if ($1 == 8) {
    %cp = %editaxis_ [ $+ [ $did(mbuild,331) ] ]
    return %cp
  }
  tokenize 32 $did(mbuild,$1)
  var %n = $int($calc((($2 - $1) + 1) / 2))
  var %a = %edit_ [ $+ [ $calc(($1 - 1) + %n) ] ]
  inc %n
  var %b = %edit_ [ $+ [ $calc(($1 - 1) + %n) ] ]
  %cp = $midpoint(%a,%b)
  if ($calc((($2 - $1) + 1) % 2)) %cp = %pnt_ [ $+ [ $calc(($1 - 1) + %n) ] ]
  return %cp
}
alias align_axis {
  var %cp = $curve_cp(6)
  var %scp = $curve_cp(7)
  tokenize 32 $did(mbuild,7)
  var %i = $1, %p, %r, %v = $subv(%cp,%scp)
  while (%i < $2) {
    inc %i
    %p = %edit_ [ $+ [ %i ] ]
    %p = $addv(%p,%v)
    ; %p = $subv(%p,%cp)
    ; %p = $poptmatrix(%p,%drw.matrix)
    ; %p = $multv2($gettok(%p,1-2,32),0.6) $gettok(%p,3,32)
    ; %p = $addv(%p,%cp)
    drawdot %drw.win 0 2 %p
    %edit_ [ $+ [ %i ] ] = $vrnd6(%p)
    ; e %p
  }
}

alias moveobj {
  tokenize 32 $1-
  if ($0 == 3) {
    var %i = 0, %n = $lines(%drw.pnt.file), %r
    while (%i < %n) {
      inc %i
      %r = $read(%drw.pnt.file,n,%i)
      if (%r) write $+(-l,%i) %drw.pnt.file $vrnd4($addv(%r,$1-))
      else _e null read
    }
    _e Finished moving
  }
  else _e Cannot move
}
alias string_range {
  ; //e $string_range(252,236)
  var %j = $1, %i = 0, %n = $calc($1 - $2)
  var %r = 0, %s
  if ($1 > $2) %r = 1
  %n = $abs(%n)
  inc %n
  while (%i < %n) {
    inc %i
    %s = %s %j
    if (%r) dec %j
    else inc %j
  }
  if (!%s) _e string error
  return %s
}
alias add_clk_pnts {
  if ($did(mbuild,308).state) daxiscap
  else {
    inc %drw.pni
    %pnt_ [ $+ [ %drw.pni ] ] = $doubletcast($mouse.x) $doubletcast($mouse.y) 0.0
    drawdot %drw.win 9 2 $mouse.x $mouse.y
    rangeset
  }
}
alias rangeset {
  var %b = $checksel
  if (%b) {
    tokenize 32 $did(mbuild,%b)
    var %s = $1
    if (!%s) {
      if (%b == 7) %s = %drw.pni + 1
      else { %s = 1 | %drw.pni = 1 }
    }
    did -o mbuild %b 1 %s %drw.pni
    did -o mbuild 329 1 %drw.pni
  }
}
alias daxiscap {
  %makeax = 1
  var %p = $doubletcast($mouse.x) $doubletcast($mouse.y) 0.0
  %axis_1 = %p
}
alias uaxiscap {
  var %p = $doubletcast($mouse.x) $doubletcast($mouse.y) 0.0
  var %n = $did(mbuild,331)
  %axis_ [ $+ [ %n ] ] = %p
  var %i = 2, %j = 0
  var %v = $subv(%p,%axis_1)
  var %l = $calc($vlen(%v) / (%n - 1))
  var %norm = $normalize(%v)
  while (%i < %n) {
    inc %j
    %axis_ [ $+ [ %i ] ] = $vrnd4($addv(%axis_1,$multv(%norm,$calc(%l * %j))))
    inc %i
  }
  did -o mbuild 8 1 1 %n
  draw_range_x 0 2 $did(mbuild,8)
  unset %makeax
  drawdot %drw.win
}

alias dragpoint {
  var %mx = %sc.mx - $mouse.x
  var %my = %sc.my - $mouse.y
  ; 
  var %v
  if (($mouse.key & 1) && (%drw.edmode > 1)) {
    ; if (($did(mbuild,303).state) || ($did(mbuild,304).state)) {
    if ($did(mbuild,2).state) %v = %mx %my 0.0
    else if ($did(mbuild,3).state) %v = %mx 0.0 0.0
    else if ($did(mbuild,4).state) %v = 0.0 %my 0.0
    else if ($did(mbuild,5).state) { _e cant tell how far to drag Z, I'm not psychic. | halt }
    ; %v = 0.0 0.0 %my
    drawdot -n %drw.win 1 2 %drw.save
    %drw.save = $subv(%drw.save,%v)
    drawdot -n %drw.win 13 2 %drw.save
    %sc.mx = $mouse.x
    %sc.my = $mouse.y
    drawdot %drw.win
  }
  ; }
  ; if ($did(mbuild,304).state)
  ; if ($did(mbuild,305).state)
}
alias predinit {
  %sc.mx = $mouse.x
  %sc.my = $mouse.y
  %clk.cap = $checksel
  ; move
  if ($did(mbuild,303).state) {
    ; subobj
    ; if ($did(mbuild,302).state)
    dinit
  }
  ; rot
  if ($did(mbuild,304).state) dinit
  ; scale
  if ($did(mbuild,305).state) dinit
}
alias dinit {
  ; drag a point, move sub object
  tokenize 32 $did(mbuild,%clk.cap)
  if ($0 == 2) {
    var %i = $1, %l, %m = $factor(14), %p, %j, %v = $mouse.x $mouse.y 0.0
    dec %i
    while (%i < $2) {
      inc %i
      if (%clk.cap == 8) %p = %editaxis_ [ $+ [ %i ] ]
      else %p = %edit_ [ $+ [ %i ] ]
      %l = $vlen($subv(%p,$gettok(%v,1-2,32),$gettok(%p,3,32)))
      if (%l < %m) { %m = %l | %j = %i }
    }
    %drw.dragi = %j
    if (%clk.cap == 8) %drw.save = %editaxis_ [ $+ [ %drw.dragi ] ]
    else %drw.save = %edit_ [ $+ [ %drw.dragi ] ]
    e %drw.dragi
  }
}
alias dragu {
  var %sb = $did(mbuild,302).state
  if (%drw.edmode > 1) {
    if (%clk.cap) {
      if ($did(mbuild,303).state) {
        ; move
        if (%sb) {
          ; subobj
          if (%clk.cap == 8) %editaxis_ [ $+ [ %drw.dragi ] ] = $vrnd6(%drw.save)
          else %edit_ [ $+ [ %drw.dragi ] ] = $vrnd6(%drw.save)
        }
        else move_all
      }
      else if ($did(mbuild,304).state) {
        ; rot
        rotselection
        if (%sb) {
          ; subobj
        }
      }
      else if ($did(mbuild,305).state) {
        ; scale
        _scale
        if (%sb) {
          ; subobj
        }
      }
    }
  }
  else if (%drw.edmode == 1) {
    if ($did(mbuild,308).state) {
      ; axis
      if (%makeax == 1) uaxiscap
    }
  }
}
alias _scale {
  var %a, %cp = $curve_cp(%clk.cap)
  if (%clk.cap == 8) %a = %editaxis_ [ $+ [ %drw.dragi ] ]
  else %a = %edit_ [ $+ [ %drw.dragi ] ]
  var %v = $subv(%a,%cp)
  var %l = $calc($vlen($subv(%drw.save,%cp)) / $vlen(%v))
  drawdot -n %drw.win 1 2 %drw.save
  tokenize 32 $did(mbuild,%clk.cap)
  var %i = $1, %p, %n = $did(mbuild,309).state
  if ($0 == 2) {
    dec %i
    while (%i < $2) {
      inc %i
      if (%clk.cap == 8) %p = %editaxis_ [ $+ [ %i ] ]
      else %p = %edit_ [ $+ [ %i ] ]
      drawdot -n %drw.win 1 2 %p

      %p = $subv(%p,%cp)
      %p = $multv(%p,%l)
      %p = $addv(%p,%cp)

      if (%clk.cap == 8) %editaxis_ [ $+ [ %i ] ] = %p
      else %edit_ [ $+ [ %i ] ] = %p
      drawdot -n %drw.win 13 2 %p
      if (%n) drawtext -n %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
      drawdot %drw.win
    }
  }
}
alias move_all {
  var %a
  if (%clk.cap == 8) %a = %editaxis_ [ $+ [ %drw.dragi ] ]
  else %a = %edit_ [ $+ [ %drw.dragi ] ]
  var %v = $subv(%drw.save,%a)
  drawdot -n %drw.win 1 2 %drw.save
  tokenize 32 $did(mbuild,%clk.cap)
  var %i = $1, %p, %n = $did(mbuild,309).state
  if ($0 == 2) {
    dec %i
    while (%i < $2) {
      inc %i
      if (%clk.cap == 8) %p = %editaxis_ [ $+ [ %i ] ]
      else %p = %edit_ [ $+ [ %i ] ]
      drawdot -n %drw.win 1 2 %p
      %p = $vrnd6($addv(%p,%v))
      if (%clk.cap == 8) %editaxis_ [ $+ [ %i ] ] = %p
      else %edit_ [ $+ [ %i ] ] = %p
      drawdot -n %drw.win 13 2 %p
      if (%n) drawtext -n %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
      drawdot %drw.win
    }
  }
}
alias apply {
  if ($did(mbuild,303).state) {
    ; move
  }
  if ($did(mbuild,304).state) {
    ; rot
    if ($did(mbuild,314)) {
      if ($did(mbuild,314)) rotcurve $did(mbuild,314) $checkconstr
    }
  }
  if ($did(mbuild,305).state) {
    ; scale
    if ($did(mbuild,315)) scale2cp $did(mbuild,315) $checkconstr
  }
}
alias scale2cp {
  var %d = $1, %a = $2, %cp = $curve_cp(%clk.cap)
  tokenize 32 $did(mbuild,%clk.cap)
  var %i = $1, %n = $2, %num = $did(mbuild,309).state
  ; if (%clk.cap == 8) %cp = %editaxis_ [ $+ [ %n ] ]

  %camrotv = 0 0 %d
  if (%a == 3) %camrotv = %d 0 0
  if (%a == 4) %camrotv = 0 %d 0
  dec %i
  while (%i < %n) {
    inc %i
    if (%clk.cap == 8) %p = %editaxis_ [ $+ [ %i ] ]
    else %p = %edit_ [ $+ [ %i ] ]
    drawdot -n %drw.win 1 2 %p
    %p = $subv(%p,%cp)

    tokenize 32 %p
    ; X only
    if (%a == 3) %p = $calc($1 * %d) $2 $3
    ; y only
    if (%a == 4) %p = $1 $calc($2 * %d) $3
    ; no Z
    if (%a == 2) %p = $multv2($gettok(%p,1-2,32),%d) $3
    if (%a == 5) %p = $multv(%p,%d)
    %p = $addv(%p,%cp)
    if (%clk.cap == 8) %editaxis_ [ $+ [ %i ] ] = %p
    else %edit_ [ $+ [ %i ] ] = %p
    drawdot -n %drw.win 13 2 %p
    if (%num) drawtext -n %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    drawdot %drw.win
  }
}
alias rotcurve {
  ; (degrees,xy xyz 2-5)
  ; //rotcurve 30 $checkconstr
  var %d = $deg2rad($1), %a = $2, %cp = $curve_cp(%clk.cap)
  tokenize 32 $did(mbuild,%clk.cap)
  var %p, %i = $1, %n = $2, %num = $did(mbuild,309).state
  ; if (%clk.cap == 8) %cp = %editaxis_ [ $+ [ %n ] ]

  %drw.matrix = 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0
  %camrotv = 0 0 %d

  if (%a == 3) %camrotv = %d 0 0
  if (%a == 4) %camrotv = 0 %d 0

  ; if ($gettok(%v2,3,32) > 0) %camrotv = 0 0 $calc(%d * -1)
  %drw.matrix = $gimbalmatrix(%drw.matrix)
  dec %i
  while (%i < %n) {
    inc %i
    if (%clk.cap == 8) %p = %editaxis_ [ $+ [ %i ] ]
    else %p = %edit_ [ $+ [ %i ] ]
    drawdot -n %drw.win 1 2 %p

    %p = $subv(%p,%cp)
    %p = $poptmatrix(%p,%drw.matrix)
    %p = $addv(%p,%cp)
    if (%clk.cap == 8) %editaxis_ [ $+ [ %i ] ] = %p
    else %edit_ [ $+ [ %i ] ] = %p
    drawdot -n %drw.win 13 2 %p
    if (%num) drawtext -n %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    drawdot %drw.win
  }
}
alias rotselection {
  ; by mouse x y
  var %a, %cp
  tokenize 32 $did(mbuild,%clk.cap)
  var %p, %i = $1, %n = $2, %num = $did(mbuild,309).state
  if (%clk.cap == 8) {
    %a = %editaxis_ [ $+ [ %drw.dragi ] ]
    %cp = %editaxis_ [ $+ [ %n ] ]
  }
  else {
    %a = %edit_ [ $+ [ %drw.dragi ] ]
    %cp = $curve_cp(%clk.cap)
  }
  var %v = $subv(%drw.save,%a)
  tokenize 32 %cp %drw.save %a
  var %v2 = $subv2($4 $5, $1 $2) 0.0
  %v2 = $crossprod( [ $subv2($7 $8, $1 $2) ] 0.0, %v2)
  %a = $radang32d($1 $2, $4 $5, $7 $8)

  %drw.matrix = 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0
  %camrotv = 0 0 %a
  if ($gettok(%v2,3,32) > 0) %camrotv = 0 0 $calc(%a * -1)
  %drw.matrix = $gimbalmatrix(%drw.matrix)
  drawdot -n %drw.win 1 2 %drw.save
  dec %i
  while (%i < %n) {
    inc %i
    if (%clk.cap == 8) %p = %editaxis_ [ $+ [ %i ] ]
    else %p = %edit_ [ $+ [ %i ] ]
    drawdot -n %drw.win 1 2 %p

    %p = $subv(%p,%cp)
    %p = $poptmatrix(%p,%drw.matrix)
    %p = $addv(%p,%cp)

    if (%clk.cap == 8) %editaxis_ [ $+ [ %i ] ] = %p
    else %edit_ [ $+ [ %i ] ] = %p
    drawdot -n %drw.win 13 2 %p
    if (%num) drawtext -n %drw.win 0 Arial 10 $gettok(%p,1-2,32) %i
    drawdot %drw.win
  }
}
alias factor {
  if ($1 > 170) return 7.257415615307994e+306
  ; max = 170
  var %i = $int($1)
  var %f = 1
  while (%i > 0) {
    ; %f = %f * %i
    if ($len(%f) < 15) %f = $lmult(%f, %i)
    else %f = $emult(%f, %i)
    dec %i
    ; else return 1.8e308+INF
  }
  return %f
}
alias nipplecontrol {
  ; write -c breast_lpnt.txt
  var %mp = $midpoint(%pnt_10,%pnt_11)
  var %nmp = $midpoint(%pnt2_164,%pnt2_168)
  var %v = $subv(%mp,%nmp)
  var %i = 160, %p
  %drw.matrix = 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0
  %camrotv = 0 0 -0.2
  %drw.matrix = $gimbalmatrix(%drw.matrix)
  while (%i < 176) {
    inc %i
    %p = %pnt2_ [ $+ [ %i ] ]

    %p = $subv(%p,%nmp)
    %p = $poptmatrix(%p,%drw.matrix)
    %p = $multv(%p,0.6)
    %p = $addv(%p,%nmp)

    %p = $addv(%p,%v)
    %p = $addv(%p,5.0 -1.5 0.0)
    ; e %nmp
    drawdot %drw.win 9 2 %p
    ; write breast_lpnt.txt %p
    %pnt2_ [ $+ [ %i ] ] = %p

  }
}
