alias smooth_obj_pov1a {
  var %rp = %drw.pnt.file, %rf = %drw.fce.file
  if ($1) %rp = $1 | if ($2) %rf = $2
  if (!%framei) %framei = 0
  inc %framei
  ; var %f1 = $+($scriptdir,smooth_,%objname,$pad(%framei,3,0),.pov)
  var %f1 = $+($mircdir,creation\smooth_,%objname,$pad(%framei,3,0),.pov)
  var %f = $+($scriptdir,pov-mesh_1.txt)
  .copy -o %f %f1
  var %i = 0, %p, %s = 1.0, %sz = $did(mbuild,577).text
  camera_writer %f1
  light_writer %f1
  if ($did(mbuild,508).text) write %f1 sky_sphere $chr(123) $did(mbuild,508).text $chr(125)

  var %bg
  ; bg_water
  ; a floor
  if ($did(mbuild,506).seltext) {
    %bg = $did(mbuild,506).seltext
    if (%bg) write %f1 object $chr(123) %bg $chr(125)
  }
  ; or bg
  if ($did(mbuild,507).seltext) {
    %bg = $did(mbuild,507).seltext
    if (%bg) write %f1 object $chr(123) %bg $chr(125)
  }

  ; write %f1 object $chr(123)
  write %f1 mesh $chr(123)
  var %n = $lines(%rf), %norm = 0.0 0.0 0.0, %face, %j = 0, %smoothangle = 70.0
  var %center = $findcenter(%rp), %k = 0, %fce, %currnorm, %newnorm, %ang
  var %m = %obj0matrix
  while (%i < %n) {
    if ($calc(%i % 10) == 0) _e %i of %n
    inc %i
    %face = $read(%rf,n,%i)
    write %f1 smooth_triangle $chr(123)
    %j = 0
    %currnorm = $nnormalvector($reversey($poptmatrix($read(%rp,n,$gettok(%face,1,32)),%m)), $&
      $reversey($poptmatrix($read(%rp,n,$gettok(%face,2,32)),%m)), $&
      $reversey($poptmatrix($read(%rp,n,$gettok(%face,3,32)),%m)))

    while (%j < 3) {
      inc %j
      %p = $reversey($poptmatrix($read(%rp,n,$gettok(%face,%j,32)),%m))
      %k = 0
      %norm = 0.0 0.0 0.0
      while (%k < %n) {
        inc %k
        %fce = $gettok($read(%rf,n,%k),1-3,32)
        if ($findtok(%fce,$gettok(%face,%j,32),1,32)) {
          %newnorm = $nnormalvector($reversey($poptmatrix($read(%rp,n,$gettok(%fce,1,32)),%m)), $&
            $reversey($poptmatrix($read(%rp,n,$gettok(%fce,2,32)),%m)), $&
            $reversey($poptmatrix($read(%rp,n,$gettok(%fce,3,32)),%m)))
          %ang = $angle2(%currnorm, %newnorm)
          if ((%ang < %smoothangle) && (%ang > 0.2)) %norm = $addv(%norm,%newnorm)
        }
      }
      if (%norm == 0.0 0.0 0.0) %norm = %currnorm
      if (10) {
        %norm = $vrnd4($normalize(%norm))
        ; $multv(%norm,-1.0) no change, pov probably decides norm direction
        if (%sz) %p = $multv(%p,%sz)
        else %p = $divv(%p,0.4)
        ; %p = $subv(%p,%center)
        tokenize 32 $_vrnd(4,%p)
        write %f1 $+(<,$1,$chr(44),$calc(1 * $2),$chr(44),$3,>,$chr(44))

        tokenize 32 $_vrnd(4,%norm)
        if (%j == 3) write %f1 $+(<,$1,$chr(44),$calc(1 * $2),$chr(44),$3,>)
        else write %f1 $+(<,$1,$chr(44),$calc(1 * $2),$chr(44),$3,>,$chr(44))
      }
    }
    write %f1 $chr(125)
  }
  ; halt
  ; green spiral Mesh_TextureB
  ; metal M_TextureA
  var %pig, %mtex, %gtex
  ; %pig = P_IM_Earth | %mtex = T_Chrome_3C | %gtex = G_TextureB


  if ($did(mbuild,503).text) %pig = $did(mbuild,503).text
  else if ($did(mbuild,504).text) %mtex = $did(mbuild,504).text
  else if ($did(mbuild,505).text) %gtex = $did(mbuild,505).text
  else { _e no texture selected | halt }

  if (%pig) {
    write %f1 pigment $chr(123) %pig $chr(125)
    write %f1 finish $chr(123) ambient 0.3 specular 0.1 diffuse 0.7 $chr(125)
  }
  else if (%mtex) {
    write %f1 texture $chr(123) %mtex $chr(125)
  }
  else if (%gtex) {
    write %f1 texture $chr(123) %gtex $chr(125)
    write %f1 interior $chr(123) Interior_Glass caustics 1 $chr(125)
  }
  else if (0) {
    write %f1 texture $chr(123) HEAD_medium_gre $chr(125)
  }
  else if (0) {
    write %f1 pigment $chr(123) P_IM_head $chr(125)
    write %f1 finish $chr(123) ambient 0.3 specular 0.1 diffuse 0.7 $chr(125)
  }
  else if (0) {
    write %f1 pigment $chr(123) P_IM_Face $chr(125)
    write %f1 finish $chr(123) ambient 0.3 specular 0.1 diffuse 0.7 $chr(125)
  }
  else if (0) write %f1 texture $chr(123) M_TextureA $chr(125)
  else {
    write %f1 texture $chr(123) G_TextureA $chr(125)
    write %f1 interior $chr(123) Interior_Glass caustics 1 $chr(125)
  }
  var %tv = %center
  if (%obj.tv) %tv = %obj.tv
  write %f1 matrix $povmatrix1a($yhid($vdeg2rad($did(mbuild,501))),0 0 0)
  write %f1 $chr(125)
  ; write %f1 $chr(125)
  if ($exists($+($gettok(%f1,1,46),.bmp))) remove $+($gettok(%f1,1,46),.bmp)
  object_export  %f1
}
alias povmatrix1a {
  ; var %d1 = 0 0 0
  ; if ($0 == 3) %d1 = $1-
  ;  var %m = %obj0matrix
  ; $gettok(%obj0matrix,1-3,32) $multv($gettok(%obj0matrix,4-6,32),-1) $gettok(%obj0matrix,7-9,32)
  ;  tokenize 32 $vrnd6(%m) %d1
  ; tokenize 32 $vrnd6($invt(%obj0matrix)) %d1
  tokenize 32 $vrnd4($1-)
  return $+(<,$1,$chr(44),$2,$chr(44),$3,$chr(44),$4,$chr(44),$5,$chr(44),$6, $&
    $chr(44),$7,$chr(44),$8,$chr(44),$9,$chr(44),$10,$chr(44),$11,$chr(44),$12,>)
}
