
on *:load: {
  .load -rs $scriptdir $+ camera.mrc
  .load -rs $scriptdir $+ meshdll.mrc
  .load -rs $scriptdir $+ mbuild2.mrc
  .load -rs $scriptdir $+ warbird2.mrc
  .load -rs $scriptdir $+ elements.mrc
  .load -rs $scriptdir $+ elements.mrc
  .load -rs $scriptdir $+ pov.mrc
  load -rs $scriptdir $+ pov-pal.mrc
  .load -rs $scriptdir $+ wrlreader.mrc
  .load -rs $scriptdir $+ mesh.mrc
  load -rs $scriptdir $+ egg.mrc
  load -rs $scriptdir $+ floors.mrc
}
menu menubar {
  -
  Builder Window: { drawwin 1 }
  Draw Object: { camerror | drawing }
}
alias _e { echo -s $1- }
alias e { echo -s $1- }
alias ec { echo -s $calc($1-) }
menu @MeshEdit {
  sclick: {
    %sc.mx = $mouse.x
    %sc.my = $mouse.y
    dragclk
    wthe
  }
  mouse: if (!%clk.cap) rollmouse
  WRL Files: wrlfiles
  Open Builder: openbuilder
  Clear: winclear
  Close: close -@ %drw.win
}
alias winclear {
  if ($did(mbuild,223)) %drw.bgc = $did(mbuild,223)
  else %drw.bgc = 1
  drawbg %drw.bgc
  drawdot %drw.win
}
alias wthe {
  if (0) {
    var %l, %n
    %l = $vlen($calc(%sc.mx - %drw.cen.x),$calc(%sc.my - %drw.cen.y) ,0))
    %n = $normalize($calc(%sc.mx - %drw.cen.x),$calc(%sc.my - %drw.cen.y),0.0))
    ; e l= $vlen($multv(%n,$calc(%l / 42.0))) $multv(%n,$calc(%l / 44.5))
  }
}
alias drawwin {
  ; close and menu dont resolve wn
  _loadll
  %PI = 3.1415926535897932
  %PI2 = $lmult(2.0,%PI)
  %PI.5 = $ldiv(%PI,2.0)
  %PI1.5 = $ladd(%PI.5, %PI)
  %cx = $window(-1).w / 2 | %cy = $window(-1).h / 2
  %drw.win = @MeshEdit
  if ($2) {
    %drw.w = $1 | %drw.h = $2 | %drw.cen.x = $int($calc(%drw.w / 2)) | %drw.cen.y = $int($calc(%drw.h / 2))
    if ($window(%drw.win) == $null) window -pd +d %drw.win $calc(%cx - %drw.cen.x) $calc(%cy - %drw.cen.y) %drw.w %drw.h eye.ico
    drawrect -f %drw.win 1 1 0 0 %drw.w %drw.h
  }
  else if ($1) {
    if ($window(%drw.win) == $null) {
      var %nullwin = 1
      window -pdk %drw.win globe.ico
    }
    %drw.w = $window(%drw.win).w | %drw.h = $window(%drw.win).h
    %drw.cen.x = $int($calc(%drw.w / 2)) | %drw.cen.y = $int($calc(%drw.h / 2))
    if (%nullwin) drawrect -f %drw.win 1 1 0 0 %drw.w %drw.h
    if (%rendmeth) {
      if ($window(@buf) == $null) {
        window -phBnd +d @buf 0 0 %drw.w %drw.h
        drawrect -f @buf 1 1 0 0 %drw.w %drw.h
      }
    }
  }
  else {
    %drw.w = $window(-1).w | %drw.h = $window(-1).h | %drw.cen.x = $int($calc(%drw.w / 2)) | %drw.cen.y = $int($calc(%drw.h / 2))
    if ($window(%drw.win) == $null) {
      window -pBd +d %drw.win 0 0 %drw.w %drw.h globe.ico
      drawrect -f %drw.win 1 1 0 0 %drw.w %drw.h
    }
    %drw.w = $calc($window(%drw.win).w - 10) | %drw.h = $calc($window(%drw.win).h - 33)
    %drw.cen.x = $int($calc(%drw.w / 2)) | %drw.cen.y = $int($calc(%drw.h / 2))
    drawrect -f %drw.win 1 1 0 0 %drw.w %drw.h
  }
  if ($1) {
    ; bordered win
    %drw.w = $calc($window(%drw.win).w - 10) | %drw.h = $calc($window(%drw.win).h - 33)
    %drw.cen.x = $int($calc(%drw.w / 2)) | %drw.cen.y = $int($calc(%drw.h / 2))
    ; drawrect -f %drw.win 1 1 0 0 %drw.w %drw.h
  }
  matpos
}
alias rollmouse {
  titlebar %drw.win $mouse.x $mouse.y
  ; $calc($mouse.x - %drw.cen.x) $calc($mouse.y - %drw.cen.y)
  if (0) {
    ; %drw.nobjs > 1
    uncheck3 173
    did -c mbuild 173
    %rmeth = 2
  }
  if ($mouse.key & 1) {
    if ($did(mbuild,414).state) { dragimg | halt }
    ; did -u mbuild 225
    var %mx = %sc.mx - $mouse.x
    var %my = %sc.my - $mouse.y
    var %i = 50, %m
    if ($mouse.key & 4) %i = 100
    if (0) {
      %mx = %mx / %i
      %my = $calc((%my / %i) * -1)
    }
    else {
      %mx = $calc((%mx / %i) * -1)
      %my = $calc(%my / %i)
    }
    if (%drw.dialog) {
      if ($did(mbuild,2).state) %camrotv = %my %mx 0
      else if ($did(mbuild,3).state) %camrotv = %my 0 0
      else if ($did(mbuild,4).state) %camrotv = 0 %mx 0
      else if ($did(mbuild,5).state) %camrotv = 0 0 %my
    }
    else %camrotv = %my %mx 0

    %m = % [ $+ [ $+(obj,%dr.curob,matrix) ] ]
    %m = $gimbalmatrix(%m)
    % [ $+ [ $+(obj,%dr.curob,matrix) ] ] = %m
    ; % [ $+ [ $+(obj,%dr.curob,imatrix) ] ] = $invt(%m)
    drawing
    %sc.mx = $mouse.x
    %sc.my = $mouse.y
    if (0) {
      did -o mbuild 6 1 $radec(%obj0matrix).dec
      did -o mbuild 7 1 $radec(%obj0matrix).ra
      did -o mbuild 8 1 $_z(%obj0matrix)
    }
  }
}
alias rep0.0 {
  if ($chr(44) isin $1) tokenize 44 $1
  else tokenize 32 $1-
  var %i = 0, %s, %n
  while (%i < $0) {
    inc %i
    %n = $gettok($1-,%i,32)
    if (%n == 0.0)  %n = 0
    %s = %s %n
  }
  return %s
}
alias test {
  var %r = 1, %rr = !(%r)
  if (%rr) e hello %rr
}
alias _! {
  if ($1) return 0
  return 1
}
alias gimbalmatrix1 {
  ; nar = not axis rot
  ; var %nar = 0
  var %up = $gettok($1-,4-6,32), %eye = $gettok($1-,7-9,32), %v = %eye
  tokenize 32 %camrotv
  if (($3) && ($3 != 0.0)) {
    ;  if (%nar) %v = 0.0 0.0 1.0
    %up = $lrotation($3, %v, %up)
    ; if (%nar) %eye = $lrotation($3, %v, %eye)
  }
  if (($2) && ($2 != 0.0)) {
    %v = %up
    ;  if (%nar) %v = 0.0 1.0 0.0
    %eye = $lrotation($2, %v, %eye)
    ;  if (%nar) %up = $lrotation($2, %v, %up)
  }
  if (($1) && ($1 != 0.0)) {
    %v = $crossprod(%up,%eye)
    ; if (%nar) %v = 1.0 0.0 0.0
    %eye = $lrotation($1, %v, %eye)
    %up = $lrotation($1, %v, %up)
  }
  %v = $normalize($crossprod(%up,%eye))
  %up = $normalize($crossprod(%eye, %v))
  %eye = $normalize($crossprod(%v,%up))
  %camrotv = 0 0 0
  return %v %up %eye
  ; 0.0 0.0 0.0
}
alias testdll {
  ; tests deltok() and new _gettok() _numtok() C func
  _e $dll(meshview.dll,lgettokk,the rat ran up the hill 3 32)
  ; testing _numtok()
  _e $dll(meshview.dll,lgettokk,the rat ran up the hill 0 32)
  _e $dll(meshview.dll,lgettokk,::::the:rat:ran:up:the:hill:: 1 58)
}
alias poptmatrix {
  ; (v,m[9])
  var %x = $gettok($2,1-3,32), %y = $gettok($2,4-6,32), %z = $gettok($2,7-9,32)
  tokenize 32 $1
  %x = $multv($normalize(%x),$1)
  %y = $multv($normalize(%y),$2)
  %z = $multv($normalize(%z),$3)
  return $addv3(%x,%y,%z)
}
alias facepnts {
  ; (pnt line nums)
  ; var %f = $line_of_face($1-)
  tokenize 32 $1-
  var %i = 0,  %r, %n = $0, %s = $1-
  while (%i < %n) {
    inc %i
    %r = $read(%drw.pnt.file,$gettok(%s,%i,32))
    if (%r) _e $gettok(%s,%i,32) %r
    else _e not found
  }
}
alias line_of_face {
  ; (face - any order)
  var %i = 0, %n = $lines(%drw.fce.file), %r, %str
  tokenize 32 $1-
  while (%i < %n) {
    inc %i
    %r = $read(%drw.fce.file,%i)
    if (($1 isin %r) && ($2 isin %r) && ($3 isin %r)) return %i %r
  }
  return not found
}
alias remove_face {
  ; (line nums in reverse order highest first)


}
alias line_of_faces {
  var %s = 91 93 123 : 91 123 121 : 121 123 153 : 121 151 153 : 151 183 153 : 181 183 151 : 181 211 213: 181 213 183 : $&
    331 333 301 : 301 333 303 : 301 303 271 : 271 303 273: 271 273 241 : 241 273 243 : 241 243 211 : 211 243 213 :
  if ($1) %s = $1-
  var %i = 0, %n = $numtok(%s,58), %r, %str
  while (%i < %n) {
    inc %i
    %r = $line_of_face($gettok(%s,%i,58))
    %str = $addtok(%str,$gettok(%r,2,32),32)
    %str = $addtok(%str, $gettok(%r,3,32),32)
    %str = $addtok(%str, $gettok(%r,4,32),32)
    _e %r
  }
  _e **********************************
  _e %str
  _e **********************************
  facepnts %str
  _e **********************************
}
alias add_pnts {
  %pnt_ [ $+ [ %drw.pni ] ] = $doubletcast($mouse.x) $doubletcast($mouse.y) 0.0
  drawdot %drw.win 9 2 $mouse.x $mouse.y
  inc %drw.pni
}
alias mirror_clone {
  ; %drw.fce.file the loaded file
  var %f = %drw.pnt.file
  var %nf, %np
  var %r = $left($right(%f,8),1)
  if (%r == l) {
    var %nf = $+($left(%drw.fce.file,-8),rfce.txt)
    var %np = $+($left(%drw.pnt.file,-8),rpnt.txt)
  }
  else {
    %nf = $+($left(%drw.fce.file,-8),lfce.txt)
    %np = $+($left(%drw.pnt.file,-8),lpnt.txt)
  }
  if (%nf == %np) { _e mirror clone: same file | halt }
  write -c %np
  var %i = 0, %n = $lines(%f), %r, %v
  var %t = $did(mbuild,260)
  while (%i < %n) {
    inc %i
    %r = $read(%f,n,%i)
    %v = $calc($gettok(%r,1,32) * -1) $gettok(%r,2-3,32)
    write %np $vrnd6($addv(%v,%t))
  }
  _e Mirror file: %np
  ; .copy -o %f mirrorbckp.txt
  if (1) {
    copy -o %drw.fce.file %nf
    ; %drw.fce.file = %nf
    _e Reversing normals for %nf
    reverse_normals %nf
  }
}
alias reverse_normals {
  ; (file)
  var %i = 0, %n, %r
  var %f = $1
  if (!%f) { _e reverse norms: nofile | halt }
  %n = $lines(%f)
  while (%i < %n) {
    inc %i
    %r = $read(%f,n,%i)
    tokenize 32 %r
    write $+(-l,%i) %f $3 $2 $1 $4
  }
  e %f finished reversing normals - reload
}
alias save_translation {
  var %i = 0, %n, %r
  var %f =  %drw.pnt.file
  var %t = $doubletcast($divv($did(mbuild,260), $did(mbuild,282)))
  %n = $lines(%f)
  while (%i < %n) {
    inc %i
    %r = $read(%f,n,%i)
    write $+(-l,%i) %f $vrnd6($addv(%t,%r))
  }
  did -o mbuild 260 1 0.0 0.0 0.0
  e %f finished saving translation - reload
  drawdot %drw.win 0 2 %drw.cen.x %drw.cen.y
}
alias vdeg2rad {
  tokenize 32 $1-
  return $calc($1 / 57.295779513082323) $calc($2 / 57.295779513082323) $calc($3 / 57.295779513082323)
}
alias _? {
  if ($1) %exec = $1
  else { echo -s invalid paramter | halt }
  if ($2) %text = $2
  else %text = Enter Reply:
  if ($3) %fillp = $3
  else %fillp = 0
  .dialog -ma replyrequest replyrequest
  did -o replyrequest 2 1 %fillp
  did -c replyrequest 2 1
  return 0
}
dialog replyrequest {
  option pixels
  title "Input Request"
  size -1 -1 300 150
  icon eye.ico,-1
  text %text, 1, 12 15 276 20, center
  combo 2, 12 50 276 46, size
  ; edit %fillp, 2, 12 50 276 20
  ; (right, center, multi, pass, read, return, hsbar, vsbar, autohs, autovs, limit N)
  button "OK", 13, 80 110 62 26, ok
  button "Cancel", 14, 150 110 62 26
}
on *:dialog:replyrequest:sclick:14: {
  dialog -x replyrequest replyrequest
  unset %exec %text %fillp
}
on *:dialog:replyrequest:sclick:13: {
  var %r = $did(replyrequest,2)
  if (%r) .timer.exe -m 1 5 %exec %r
  unset %exec %text %fillp
}
alias autosize {
  ; (width)
  var %w, %x
  if ($1) %w = $1
  else %w = $findcenter(%drw.pnt.file).w
  var %z = 0, %eye = $calc($vlen($subv($did(mbuild,198),$did(mbuild,200))) * -1)

  ; %x = $calc(($angle2fol($did(mbuild,201)) / (%eye - %z)) * (%w / 2))
  ; %x = $round($calc((%drw.cen.x * 0.5) / $abs(%x)),2)

  %x = $calc((%drw.cen.x / ($angle2fol($did(mbuild,201)) / (%eye - %z))) * 2)
  %x = $round($calc(($abs(%x) / %w) * 0.5),2)
  did -o mbuild 282 1 %x
  did -o mbuild 333 1 %x
  did -o mbuild 577 1 %x
}
