
menu @SelectWRL {
  dclick: wrlread $sline(@SelectWRL,1)
  remove: fmove $sline(@SelectWRL,1)
  more wrl files: run http://www.georgehart.com/virtual-polyhedra/alphabetic-list.html
}
alias wrlread {
  var %j, %i = 0, %df = $mircdir $+ models\ $+ $1
  var %r, %f = $remove($left($1,-4),$chr(40),$chr(41))
  did -o mbuild 32 1 %f
  did -o mbuild 232 1 %f
  %drw.pnt.file = $+(%f,pnt.txt)
  %drw.fce.file = $+(%f,fce.txt)
  write -c %drw.pnt.file

  var %n = $lines(%df), %sc.obj.sz, %w = * $+ point*[*
  %r = $read(%df,nw,%w,1)
  %i = $readn
  %j = %i
  :loop | inc %i
  %r = $read(%df,%i)
  if ($chr(93) isin %r) %i = %n
  else { write %drw.pnt.file $remove(%r,$chr(44),$chr(9)) | %npts = %i - %j }
  if (%i < %n) goto loop
  e %npts in wrl file = $lines(%drw.pnt.file) verts in %drw.pnt.file
  wrlread-faces %df
  if ((srtc isin $1) || (zono isin $1)) {
    if (5 isin $1) %sc.obj.sz = 15
    else %sc.obj.sz = 36
  }
  %sc.obj.sz = 50
  if (stellated_icosahedron isin $1) %sc.obj.sz = 90
  if ($1 == great_pentagrammic_hexecontahedron.wrl) %sc.obj.sz = 40
  if ($1 == small_stellated_dodecahedron.wrl) %sc.obj.sz = 80
  if ($1 == small_rhombihexacron.wrl) %sc.obj.sz = 70
  if ($1 == decagonal_dipyramid.wrl) %sc.obj.sz = 60
  if ($1 == stellated_icosahedron_(59)_(5_color).wrl) %sc.obj.sz = 40
  if ($1 == great_pentakisdodekahedron.wrl) %sc.obj.sz = 18
  if ($1 == great_stellapentakisdodecahedron.wrl) %sc.obj.sz = 60
  if ($1 == medial_triambic_icosahedron.wrl) %sc.obj.sz = 50
  ; did -o mbuild 333 1 %sc.obj.sz
  if (0) {  
    icosidodec pnt.txt fce.txt
    copy -o pnt.txt c:\programming\mirc614\pnt.txt
    copy -o fce.txt c:\programming\mirc614\fce.txt
    copy -o pnt.txt c:\programming\mirc614m\pnt.txt
    copy -o fce.txt c:\programming\mirc614m\fce.txt
  }
}
alias rev-faces {
  var %f = $1, %s
  write -c %f
  %nfaces = $line(@sort,0)
  var %i = 0 | :loop | inc %i
  tokenize 32 $line(@sort,%i)
  write %f $1 $3 $2
  if (%i < %nfaces) goto loop
}
alias wrlread-faces {
  write -c %drw.fce.file
  var %i = 0, %f = $1, %r, %j
  var %n = $lines(%f)
  var %w = * $+ IndexedFaceSet*
  %r = $read(%f,nw,%w,1)
  %i = $readn + 1
  %j = 0
  :loop | inc %i
  %r = $read(%f,%i)
  if ($chr(93) isin %r) {
    %r = $read(%f,nw,%w,%i) | %i = $readn + 1
    if (%r) goto loop
    else %i = %n
  }
  else {
    %r = $remove($replace(%r,$chr(44),$chr(32)),$chr(9))
    if (%r) {
      ; write %drw.fce.file $deltok(%r,$numtok(%r,32),32)
      triangulate_face1 $deltok(%r,$numtok(%r,32),32)
      inc %j | %nfaces = %j
    }
  }
  if (%i < %n) goto loop
  e %nfaces = $lines(%drw.fce.file) ? faces
}
alias selectwrlwin {
  if ($window(@SelectWRL)) clear @SelectWRL
  else window -lksd +e @SelectWRL $calc($window(-3).w - 440) 10 240 $window(-3).h
}
alias wrlfiles {
  var %d = $mircdir $+ models\
  selectwrlwin
  var %f = $findfile(%d,*.wrl,0, aline @SelectWRL $nopath($1))
}
alias selectwrlwin {
  if ($window(@SelectWRL)) clear @SelectWRL
  else window -lks +e @SelectWRL $calc($window(-3).w - 440) 10 240 $window(-3).h
}
alias wing_end_caps {
  ; left end
  triangulate_face2 $string_range(110,126)
  ; right end
  triangulate_face2 $string_range(252,236)
}
alias triangulate_face1 {
  ; (full string) circular. faces changed _ 0 range to 1-n
  if ($0 == 2) {
    tokenize 32 $string_range($1,$2)
  }
  if ($0 > 2) {
    var %v, %n = $0, %i = 0, %s = $1-
    dec %n 2
    while (%i < %n) {
      inc %i
      %v = $gettok(%s,1,32) $gettok(%s,2,32) $gettok(%s,3,32)
      write %drw.fce.file $addvi(%v, 1 1 1) %drw.stripcolor
      %s = %s $gettok(%s,1,32)
      %s = $deltok(%s,1-2,32)
    }
  }
}
alias triangulate_face {
  ; (full string) circular
  if ($0 == 2) {
    tokenize 32 $string_range($1,$2)
  }
  if ($0 > 2) {
    var %v, %n = $0, %i = 0, %s = $1-
    dec %n 2
    while (%i < %n) {
      inc %i
      %v = $gettok(%s,1,32) $gettok(%s,2,32) $gettok(%s,3,32) %drw.stripcolor
      write %drw.fce.file %v
      %s = %s $gettok(%s,1,32)
      %s = $deltok(%s,1-2,32)
    }
  }
}
alias triangulate_face2 {
  ; (full string or range) cross walk - start 1st & last - end in the middle
  if ($0 == 2) {
    tokenize 32 $string_range($1,$2)
  }
  if ($0 > 2) {
    var %v, %n = $0, %i = 0, %j = %n, %s = $1-
    dec %n 2
    while (%i < %n) {
      inc %i
      %j = $numtok(%s,32)
      if ($calc(%i % 2)) %v = $gettok(%s,1,32) $gettok(%s,2,32) $gettok(%s,%j,32) %drw.stripcolor
      else %v = $gettok(%s,1,32) $gettok(%s,$calc(%j - 1),32) $gettok(%s,%j,32) %drw.stripcolor
      write %drw.fce.file %v
      if ($calc(%i % 2)) %s = $deltok(%s,1,32)
      else %s = $deltok(%s,%j,32)
    }
  }
  e %n triangles
}
alias reversey {
  ; (v)
  ; reverse y
  tokenize 32 $1-
  return $1 $lmult(-1,$2) $3
}
